// Jungler.cpp
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru

#include <afxwin.h>         // MFC core and standard components
#include <assert.h>

#undef _AFXDLL        
#undef _DLL                      
#undef _CRTIMP       
#pragma warning(disable: 4273) //inconsistent dll linkage. dllexport assumed

#include <vector>
using namespace std;
                
#include "..\AddInComm\AddInComm.h"
//#include "..\AddInComm\AICLoader.h"

#include "Jungler.h"

namespace
{
  const char AICName[] = "Jungler";
  bool Subclass(LPCTSTR pParams)
  {
    char sender[100];CWnd* newWnd;HWND prevHWND;
    if (sscanf(pParams,"%s %x %x",&sender,&newWnd,&prevHWND) != 3)
      return false;
    return AJLSubclass(sender,newWnd,prevHWND);
  }
  bool UnsubclassImmediate(LPCTSTR pParams)
  {
    char sender[100];CWnd* newWnd;
    if (sscanf(pParams,"%s %x",&sender,&newWnd) != 2)
      return false;
    return AJLUnsubclassImmediate(sender,newWnd);
  }
  bool UnsubclassBegin(LPCTSTR pParams)
  {
    char sender[100];CWnd* newWnd;
    if (sscanf(pParams,"%s %x",&sender,&newWnd) != 2)
      return false;
    return AJLUnsubclassBegin(sender,newWnd);
  }
  bool UnsubclassComplete(LPCTSTR pParams)
  {
    char sender[100];CWnd* newWnd;
    if (sscanf(pParams,"%s %x",&sender,&newWnd) != 2)
      return false;
    return AJLUnsubclassComplete(sender,newWnd);
  }
  struct command_t
  {
     LPCTSTR pName;
     bool (*pFn)(LPCTSTR pParams);
  }
  commands[] = 
  {
    {"Subclass",            Subclass},
    {"UnsubclassImmediate", UnsubclassImmediate},
    {"UnsubclassBegin",     UnsubclassBegin},
    {"UnsubclassComplete",  UnsubclassComplete},
  };
}

class Loader : public CWinApp
{
 protected:
  virtual BOOL InitInstance()
  {
    //aiclLoadAICLibrary(AfxGetInstanceHandle());
#ifdef _DEBUG
    //if(!aiclIsAICLoaded())
      //AfxMessageBox("Can't load AIC");
#endif
    AICRegisterAddIn(AICName,1,0,0,Callback);
  	return CWinApp::InitInstance();
  }
 	virtual int ExitInstance()
  {
    AICUnregisterAddIn(AICGetAddIn(AICName));
  	return CWinApp::ExitInstance();
  }
   static int Callback(LPCTSTR pCmd) // from Oz Solomonovich sample
   {
      char buf[1024];
      int i, p;
      // isolate command string (command string -> buf)
      p = 0;
      while (pCmd[p]  &&   isspace(pCmd[p])) p++;
      while (pCmd[p]  &&  !isspace(pCmd[p])) p++;
      strncpy(buf, pCmd, p);
      buf[p] = '\0';

      // see if it's a known command
      for (i = 0; i < sizeof(commands)/sizeof(commands[0]); i++)
      {
        if (_tcsicmp(buf, commands[i].pName) == 0)
        {
            // trim white space from beginning of params
            while (pCmd[p]  &&  isspace(pCmd[p])) p++;
            return (commands[i].pFn(pCmd + p));
        }
      }
      return -1;
   }
};
Loader theApp;
                         

