// Jungler.cpp
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru

#include <afxwin.h>         // MFC core and standard components
#include <assert.h>

//#include "..\AddInComm\AddInComm.h"

//#undef _AFXDLL
//#undef _DLL             
//#undef _CRTIMP
//#pragma warning(disable: 4273) //inconsistent dll linkage. dllexport assumed

#include <vector>
#include <string>
using namespace std;

#include "Jungler.h"


//=================  Class CriticalSection
class CriticalSection
{
  public:
    CriticalSection() : lockCount(0){InitializeCriticalSection(&section); }
   ~CriticalSection(){DeleteCriticalSection(&section);}
    void lock(){EnterCriticalSection(&section);lockCount++;}
    void unlock(){LeaveCriticalSection(&section);lockCount--;}
  protected:
    CRITICAL_SECTION section;
    int              lockCount;
};
//=================  Class LockSection
class LockSection
{
  public:
    LockSection( CriticalSection& aSection) : section(aSection){ section.lock();}
   ~LockSection()                                              { section.unlock();}
  private:
    CriticalSection& section;
};

//=================  Class WndTransaction
struct WndTransaction
{
#if _MSC_VER < 1200
  WndTransaction():m_wnd(0) {}
  friend inline bool operator<(const WndTransaction& x, const WndTransaction& y) {return x.m_wnd < y.m_wnd; }
  friend inline bool operator==(const WndTransaction& x, const WndTransaction& y) {return x.m_wnd == y.m_wnd; }
#endif
  WndTransaction(LPCTSTR addin,CWnd* wnd,HWND hWnd) 
    : m_addin(addin),m_wnd(wnd),m_saved_hWnd(hWnd){}
  string        m_addin;
  CWnd*         m_wnd;
  HWND          m_saved_hWnd;
};

static vector<WndTransaction> g_Actions;
static CriticalSection g_Section;

//=================  Class WndsIter
WndsIter::operator bool()
{
  return index<g_Actions.size();
}
WndsIter::operator LPCTSTR()
{
  return g_Actions[index].m_addin.c_str();
}
WndsIter::operator CWnd*()
{
  return g_Actions[index].m_wnd;
}
WndsIter::operator HWND()
{
  return g_Actions[index].m_saved_hWnd;
}

//=================  FUNCTIONS

bool AJLSubclass(LPCTSTR sender,CWnd* newWnd,HWND prevHWND)
{
  LockSection lock(g_Section);
  AfxTrace("AJLSubclass %s %x %x\n",sender,newWnd,prevHWND);
  newWnd->SubclassWindow(prevHWND);
  g_Actions.push_back(WndTransaction(sender,newWnd,prevHWND));
  return true;
}

bool AJLUnsubclassImmediate(LPCTSTR sender,CWnd* newWnd)
{
  LockSection lock(g_Section);
  AfxTrace("AJLUnsubclassImmediate %s %x\n",sender,newWnd);
  for(WndsIter it;it;it++)
  {
    if(newWnd==it)
    {
      AfxTrace("Found %x\n",HWND(it));

      for(int u=g_Actions.size()-1;u>int(it);u--)
      {
        if(g_Actions[u].m_saved_hWnd==it)
          g_Actions[u].m_wnd->UnsubclassWindow();
      }
      
      if(::IsWindow(it->m_hWnd))
      {
        it->UnsubclassWindow();
      }

      for(int s=int(it)+1;s<g_Actions.size();s++)
      {
        if(g_Actions[s].m_saved_hWnd==it)
          g_Actions[s].m_wnd->SubclassWindow(g_Actions[s].m_saved_hWnd);
      }
      
      g_Actions.erase(&g_Actions[int(it)]);

      AfxTrace("AJLUnsubclassImmediate Complete\n");
      return true;
    }
  }
  return false;
}

bool AJLUnsubclassBegin(LPCTSTR sender,CWnd* newWnd)
{


  LockSection lock(g_Section);
  AfxTrace("AJLUnsubclassBegin %s %x\n",sender,newWnd);
  for(WndsIter it;it;it++)
  {
    if(newWnd==it)
    {
      AfxTrace("Found %x\n",HWND(it));
      for(int u=g_Actions.size()-1;u>int(it);u--)
      {
        if(g_Actions[u].m_saved_hWnd==it)
        {
          /*HADDIN hAddIn = AICGetAddIn(g_Actions[u].m_addin.c_str());
          assert(hAddIn);
          if(hAddIn)
          {
            char buf[100];
            /// I think it is only for compatibidity
            sprintf(buf,"IsSubclassed %x",g_Actions[u].m_saved_hWnd);
            int ret = AICSendCommand(hAddIn,buf);
            assert(ret==1);
            if(ret==1)
            ///
            {
              sprintf(buf,"Unsubclass %x",g_Actions[u].m_saved_hWnd);
              AICSendCommand(hAddIn,buf);
            }
          } */
        }
      }
      return true;
    }
  }
  return false;
}

bool AJLUnsubclassComplete(LPCTSTR sender,CWnd* newWnd)
{
  LockSection lock(g_Section);
  AfxTrace("AJLUnsubclassComplete %s %x\n",sender,newWnd);
  for(WndsIter it;it;it++)
  {
    if(newWnd==it)
    {
      for(int s=int(it)+1;s<g_Actions.size();s++)
      {
        if(g_Actions[s].m_saved_hWnd==it)
        {
          /*char buf[100];
          HADDIN hAddIn = AICGetAddIn(g_Actions[s].m_addin.c_str());
          assert(hAddIn);
          if(hAddIn)
          {
            sprintf(buf,"Subclass %x",g_Actions[s].m_saved_hWnd);
            int ret = AICSendCommand(hAddIn,buf);
          } */
        }
      }
      
      g_Actions.erase(&g_Actions[int(it)]);

      return true;
    }
  }
  return false;
}

// MISC

int AJLGetDllVersion()
{
  return 0;
}
