// Commands.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//
#include "stdafx.h"

#include <afxole.h>
#include <io.h>

#include <vector>             
#include <algorithm>
#include <set>

using namespace std;

#include "Commands.h"
#include "SelectClassNameDP.h"
#include "Options.h"
#include "TagsListDP.h"
#include "DlgFavorites.h"
#include "DlgWinMgr.h"
#include "RegularExpressions.h"
#include "tags\Options.h"
#include "utils.h"
#include "DlgsessMgr.h"
#include "AddInComm/AddInComm.h"
#include "Registry.h"
#include "BookMarksMgr.h"
#include "TagsOfFileMgr.h"
#include "AJL\Jungler.h"


void testParse();


#undef FindText

extern tagFile TagFile;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int LockState::refcount = 0;
LockState::LockState(IApplication* pApplication)
{
  refcount++;
  m_pApplication = pApplication;
  VERIFY_OK(m_pApplication->EnableModeless(VARIANT_FALSE));
}
LockState::~LockState()
{
  refcount--;
  VERIFY_OK(m_pApplication->EnableModeless(VARIANT_TRUE));
}

BSTR CHAR2BSTR(LPCSTR lp)
{
  return A2BSTR(lp);
}

/////////////////////////////////////////////////////////////////////////////
static struct MethodNames
{
  char* textDescription;
  char* textName;
  char* textMethod;
}
gNames[] =
{
  "Displays a header with selected tag",
  "Find Tag",
  "FindClass",

  "Toggle between \"name\".cpp \"name\".h files",
  "Toggle Files",
  "ToggleFiles",

  "Sortable list of windows",
  "Windows Manager",
  "WindowsManager",

  "Sortable list of tags",
  "Tags Manager",
  "TagsManager",

  "Find selected class and insert #include \"*.h\"",
  "Add Header",
  "FindAndAddHeader",

  "Manager of Favorites Files",
  "Favorites",
  "Favorites",

  "Build selected projects and run",
  "Build And Run",
  "BuildRun",

  "Session Manager",
  "Session Manager",
  "SessionManager",

  "Update Tags Info",
  "Update Info",
  "UpdateInfo",

  "Show tags for current file",
  "Show file tags",
  "ShowFileTags",

  "Push position onto Mark Stack",
  "Push Mark",
  "PushMark",

  "Pop position from Mark Stack",
  "Pop Mark",
  "PopMark",

  "Bookmarks Manager",
  "Bookmarks Manager",
  "Bookmarks",

  "Options for this add-in",
  "Options",
  "Options",
};

/////////////////////////////////////////////////////////////////////////////
// CCommands
CCommands* CCommands::g_CCommands = NULL;

CCommands::CCommands()
{
  ASSERT(g_CCommands==NULL);
  g_CCommands = this;
	m_pApplication = NULL;
  for(int i=0;i<_dlgCount;m_dlgs[i++] = NULL);
}

CCommands::~CCommands()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
  ASSERT(g_CCommands == this);
  ClearVectors();
  for(int i=0;i<_dlgCount;NeedToDestroy(m_dlgs[i++]));
	ASSERT (m_pApplication != NULL);
	m_pApplication->Release();
  gBuild.ce_tou = true;
  gBuild.resume();
  gBuild.wait();
  g_CCommands = 0;
}

const char AICName[] = "ZManagers";

#define WM_CONNECTION (WM_USER+1)
#define WND_CONNECTION (WM_USER+2)

BEGIN_MESSAGE_MAP(ConnectionCwnd,CWnd)
 ON_MESSAGE(WM_CONNECTION, DoConnection)
END_MESSAGE_MAP()              

LONG ConnectionCwnd::DoConnection(WPARAM  wparam , LPARAM /* lparam */)
{
  Sleep(100);
	
  CCommands* _this = (CCommands*)wparam;

  //AFX_MANAGE_STATE(AfxGetStaticModuleState());

  // Inform DevStudio of the commands we implement
  for (int i=0; i<sizeof(gNames)/sizeof(gNames[0]); i++)
  {
    CString strCmdName = gNames[i].textName;
    char* method = gNames[i].textMethod;
    CString fullName = strCmdName + "\n1\n" + strCmdName + '\n' + CString(gNames[i].textDescription);
    VERIFY_OK(_this->GetApplication()->AddCommandBarButton(dsGlyph,CHAR2BSTR(strCmdName), _this->GetCookie()));
  }
  PostMessage(WM_CLOSE);

	return 0;
}


STDMETHODIMP CCommands::OnConnection(IApplication* pApp, VARIANT_BOOL bFirstTime,long dwCookie, VARIANT_BOOL* OnConnection)
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());

  // Store info passed to us
	m_pApplication = NULL;
	if(FAILED(pApp->QueryInterface(IID_IApplication, (void**) &m_pApplication)) || m_pApplication  == NULL)
	{
    *OnConnection = VARIANT_FALSE;
		return S_OK;
	}

	m_dwCookie = dwCookie;

	// The QueryInterface above AddRef'd the Application object.  It will
	//  be Release'd in CCommand's destructor.
	VERIFY(SUCCEEDED(AtlAdvise(m_pApplication, GetUnknown(), IID_IApplicationEvents, &m_dwAdvise)));

	VERIFY_OK(m_pApplication->SetAddInInfo((long) AfxGetInstanceHandle(),
		static_cast<ICommands*>(this), IDR_TOOLBAR_MEDIUM, IDR_TOOLBAR_MEDIUM, m_dwCookie));

	// Inform DevStudio of the commands we implement
  for (int i=0; i<sizeof(gNames)/sizeof(gNames[0]); i++)
  {
    CString strCmdName = gNames[i].textName;
    char* method = gNames[i].textMethod;
    CString fullName = strCmdName + "\n1\n" + strCmdName + '\n' + CString(gNames[i].textDescription);

    VARIANT_BOOL bRet;
	  VERIFY_OK(GetApplication()->AddCommand(CHAR2BSTR(fullName),CHAR2BSTR(method),i, GetCookie(), &bRet));
    if (bRet == VARIANT_FALSE)
	  {
      ::MessageBox(NULL,"AddCommand failed\n", method, MB_OK | MB_ICONINFORMATION);
		  return S_OK;
	  }
  }

  Subclass();

  bool firstInit = true;
  for(RegIterator it1(RegExclude);it1;it1++)
    firstInit = false;

  if(firstInit || bFirstTime==VARIANT_TRUE)
  {
    RECT rect;
    m_connectionCwnd.Create(0,"connectionCwnd",0,rect,GetDevOrMyWnd(),WND_CONNECTION);
    m_connectionCwnd.PostMessage(WM_CONNECTION,(WPARAM)this,0);
  }
  else
  {
    // enable run only at second or more start
    m_run.CreateShellRedirect();
  }

  AddMFCExcludeTags();

  *OnConnection = VARIANT_TRUE;
	return S_OK;
}


void CCommands::Subclass()
{
  if(getValue("Subclass",0))
  {
    AJLSubclass(AICName,&m_wnd,GetDevWnd()->m_hWnd);
  //m_wnd.SubclassWindow(hDevStudioWnd);
  }
}

void CCommands::Unsubclass()
{
  AJLUnsubclassImmediate(AICName,&m_wnd);

  //AJLUnsubclassBegin(AICName,&m_wnd);
  //m_wnd.UnsubclassWindow();
  //AJLUnsubclassComplete(AICName,&m_wnd);
  
  //   
  m_wnd.m_hWnd = NULL;
}

CWnd* CCommands::GetDevWnd()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
  CWnd* hDesktopWnd = CWnd::GetDesktopWindow();
  CWnd* hDevStudioWnd = NULL;
  m_pApplication->put_Active(VARIANT_FALSE);
  m_pApplication->put_Active(VARIANT_TRUE);
  CWnd* hWnd = CWnd::GetActiveWindow();
  while(hWnd  &&  hWnd->m_hWnd != hDesktopWnd->m_hWnd)
  {
    hDevStudioWnd = hWnd;
    hWnd = hWnd->GetParent();
  }
  return hDevStudioWnd;
}

CWnd* CCommands::GetDevOrMyWnd()
{
  return m_wnd.m_hWnd ? &m_wnd : GetDevWnd();
}

STDMETHODIMP CCommands::OnDisconnection(VARIANT_BOOL)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
  m_run.OnDestroy();
  Unsubclass();  
  AtlUnadvise(m_pApplication, IID_IApplicationEvents, m_dwAdvise);
	return S_OK;
}

CString CCommands::DSWPath="";
CString CCommands::CurrentWorkSpace = "Empty";
CString CCommands::CurrentSession = "NoName";

int CCommands::getValue(LPCTSTR cvalue,int defaultValue,LPCTSTR topic)
{
  return AfxGetApp()->GetProfileInt(topic,cvalue,defaultValue);
}

CString CCommands::getValue(LPCTSTR cvalue,LPCTSTR defaultValue,LPCTSTR topic)
{
	return AfxGetApp()->GetProfileString(topic,cvalue,defaultValue);
}

void CCommands::setValue(LPCTSTR cvalue,int newValue,LPCTSTR topic)
{
 	AfxGetApp()->WriteProfileInt(topic,cvalue,newValue);
}

void CCommands::setValue(LPCTSTR cvalue,LPCTSTR newValue,LPCTSTR topic)
{
 	AfxGetApp()->WriteProfileString(topic,cvalue,newValue);
}

HRESULT CCommands::GetActive(CComQIPtr<IGenericDocument, &IID_IGenericDocument>& pDocActive)
{
	CComPtr<IDispatch> pDispatch;
	GetApplication()->get_ActiveDocument(&pDispatch);
	if(pDispatch)
		pDocActive = pDispatch;
	pDispatch = NULL;
	return S_OK;
}

HRESULT CCommands::GetDocuments(CComQIPtr<IDocuments, &IID_IDocuments>& pDocuments)
{
  CComPtr<IDispatch> pDispatch;
	GetApplication()->get_Documents(&pDispatch);
  pDocuments = pDispatch;
	pDispatch = NULL;
	return S_OK;
}

HRESULT CCommands::GetSelection(CComQIPtr<ITextSelection, &IID_ITextSelection>& pSel)
{
  CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDocActive;
  GetActive(pDocActive);
  CComQIPtr<ITextDocument, &IID_ITextDocument> pTextDocActive(pDocActive);
  if(pTextDocActive)
  {
    CComPtr<IDispatch> pDispatch;
    HRESULT hr = pTextDocActive->get_Selection(&pDispatch);
	  pSel = pDispatch;
	  pDispatch = NULL;
  }
	return S_OK;
}

CString CCommands::GetCurrentFile()
{
  CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDocument;
  GetActive(pDocument);
  if(pDocument)
  {
    BSTR bstrName;
		if(pDocument->get_FullName(&bstrName)==S_OK)
      return CString(bstrName);
  }
  return CString();
}


long CCommands::GetCurrentLine()
{
  CComQIPtr<ITextSelection, &IID_ITextSelection> pSel;
  GetSelection(pSel);
	long line = 0;
  if(pSel)
    pSel->get_CurrentLine(&line);
  return line;
}

void CCommands::FileSaveAll()
{
  m_pApplication->ExecuteCommand(CHAR2BSTR("FileSaveAll"));
}

/////////////////////////////////////////////////////////////////////////////
// Application events
HRESULT CCommands::BeforeBuildStart()
{
	return S_OK;
}

HRESULT CCommands::BuildFinish(long, long)
{
	return S_OK;
}

HRESULT CCommands::BeforeApplicationShutDown()
{
	return S_OK;
}

HRESULT CCommands::DocumentOpen(IDispatch* theDocument)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDoc;
	pDoc = theDocument;
	if (pDoc)
		SetInfo(pDoc);
  if(!TagFile.m_files.empty())
    nFile = TagFile.getFileIndex((const char*)GetCurrentFile());
  refresh(_dlgWindows);
  refresh(_dlgFileTags);

  CDlgBookMgr::RefreshFile(GetCurrentFile());

	SetBookMarks();

	return S_OK;
}

CFileItem* CCommands::findFileItem(CComQIPtr<IGenericDocument, &IID_IGenericDocument>& pDocument)
{
  CString strFile;
	BSTR bstrName;
  if(S_OK==pDocument->get_FullName(&bstrName))
  {
  	CString strDir = bstrName;
    baseFilename(strDir,strFile,strDir);
    for(list<CFileItem*>::iterator  i = m_dirList.begin();i != m_dirList.end();++i)
  	{
  		CFileItem* pFileItem = *i;
    	if(pFileItem->m_Dir.CompareNoCase(strDir) == 0)
  		{
      	if (pFileItem->m_File.CompareNoCase(strFile) == 0)
  			{
          return pFileItem;
  			}
      }
    }
  }
  return 0;
}

HRESULT CCommands::BeforeDocumentClose(IDispatch* theDocument)
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());

  CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDocument;
	pDocument = theDocument;
	if (pDocument)
	{
  	CFileItem* pFileItem = findFileItem(pDocument);
    if(pFileItem)
    {
      delete pFileItem;
      m_dirList.remove(pFileItem);
    }
    refresh(_dlgWindows);
	}

	AddBookMarks();

	return S_OK;
}

HRESULT CCommands::DocumentSave(IDispatch* theDocument)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CComQIPtr<IGenericDocument, &IID_IGenericDocument> pGenericDocument;
	pGenericDocument = theDocument;
	if (pGenericDocument)
		SetInfo(pGenericDocument);

	return S_OK;
}

HRESULT CCommands::NewDocument(IDispatch*)
{
	return S_OK;
}

HRESULT CCommands::WindowActivate(IDispatch*)
{
	return S_OK;
}

HRESULT CCommands::WindowDeactivate(IDispatch*)
{
	return S_OK;
}

HRESULT CCommands::WorkspaceOpen()
{
	LockState lock(m_pApplication);
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

  BSTR  path;
  m_pApplication->get_CurrentDirectory(&path);
  DSWPath = path;
  addSlash(DSWPath);

  CurrentWorkSpace = path;
  TrimRight(CurrentWorkSpace,"\\");
  int idx = CurrentWorkSpace.ReverseFind('\\');
  if(idx>=0)
    CurrentWorkSpace = CurrentWorkSpace.Right(CurrentWorkSpace.GetLength()-idx-1);

	CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDocActive;
  GetActive(pDocActive);

  CComQIPtr<IDocuments, &IID_IDocuments> pDocuments;
  GetDocuments(pDocuments);
  for(DocIterator it(pDocuments);it;it++)
    SetInfo(it, false);

	if (pDocActive)
    pDocActive->put_Active(VARIANT_TRUE); // make this active again.
  ClearVectors();
  NeedToDestroy(m_dlgs[_dlgTags]);

	return S_OK;
}

HRESULT CCommands::WorkspaceClose()
{
	return S_OK;
}

HRESULT CCommands::NewWorkspace()
{
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// CCommands methods
void CCommands::GoToLine(int lines)
{
  CComQIPtr<ITextSelection, &IID_ITextSelection> pSel;
  GetSelection(pSel);
	if(pSel)
  {
     CComVariant varSelMode = dsMove;
		 pSel->GoToLine(lines+15, varSelMode);
     pSel->GoToLine(lines, varSelMode);
  }
}

void CCommands::SimpleOpenDoc(LPCTSTR fileName,int lines)
{
	CComPtr<IGenericDocument> doc;
  FindDoc(fileName,doc);
  GoToLine(lines);
}

void CCommands::AddHeader(CString fileName,int)
{
   CComQIPtr<ITextSelection, &IID_ITextSelection> pSel;
   GetSelection(pSel);
	 if(!pSel)
     return;
   CComVariant varSelMode = dsMove;
   pSel->EndOfDocument(varSelMode);
   VARIANT_BOOL pbRet;
   BSTR bsfind = CHAR2BSTR("#include");
   CComVariant opt = dsMatchBackward;
   pSel->FindText(bsfind,opt,&pbRet);
   if(!pbRet)
     pSel->StartOfDocument(varSelMode);
   else
   {
     // temp
     long lineInclude = GetCurrentLine();
     opt = dsMatchForward;
     pSel->FindText(CHAR2BSTR("#endif"),opt,&pbRet);
     if(pbRet)
     {
       long lineIfdef = GetCurrentLine();
       if(lineIfdef!=lineInclude+1)
         pSel->FindText(bsfind,opt,&pbRet);
     }
   }

   pSel->EndOfLine(varSelMode);
   pSel->NewLine(opt);

   CString str("#include \"");

   CString  nameCur,pathCur,curPath = GetCurrentFile();
   baseFilename(curPath,nameCur,pathCur);
   CString path,name,mainPath = DSWPath;
   baseFilename(fileName,name,path);
   if(path!=pathCur)
   {
     if(path.Find(DSWPath)>=0)
     {
       path.Replace(DSWPath,"");
       pathCur.Replace(DSWPath,"");
       CString pathBak;
   
       static const char separator[] = ".\\";
       const char* s = (const char*)pathCur;
       char* identifier = strtok((char*)s, separator );
       while( identifier )
       {
         pathBak += "..\\";
         identifier = strtok( NULL, separator );
       }
       name = pathBak + path + "\\" + name;
     }
   }
  
   str += name;
   str += "\"";

   pSel->put_Text(CHAR2BSTR(str));

   GoToLine(GetCurrentLine());
}

int CCommands::findTag(ClassItem& item,RegularExpression& className)
{
  int res = 0;
  for(int i=0;i<TAG_COUNT;i++)
  {
    if(i==TAG_MEMBER || i==TAG_FUNCTION || i==TAG_INCLUDE || i==TAG_EXTERN_VAR)
      continue;
    int add = findTag(item.m_children[i],className);
    if( add < 0 )
      return add;
    res += add;
  }
  return res;
}

int CCommands::findTag(VecClassItem& vect,RegularExpression& className)
{
  int res = 0;
  for (ClassItemIter it = vect.begin(); it != vect.end();it++)
  {
    if(className==it->m_name)
    {
      foundTag = it;
      if(_stricmp(it->m_name,(const char *)className)==0)
        return -1;
      CString str;
      str.Format("%s(%d):%s",it->getFile(),it->getLine(),(const char *)it->m_name);
			m_pApplication->PrintToOutputWindow(CHAR2BSTR(str));
      res++;
    }
    int add = findTag(*it,className);
    if( add < 0 )
      return add;
    res += add;
  }
  return res;
}

bool CCommands::selectTagByFile(HTREEITEM hParent)
{
  for(ItemIterator it((TagsListDP*)m_dlgs[_dlgTags],hParent);it;it++)
	{
    if(it.get())
    {
      short delta = it->countDeltaLine(nline,nFile);
      if(delta>=0 && delta<nline-sline)
      {
        selected = it;
        sline = nline - delta;
        if(delta==0)
          return true;
      }
    }
    if(selectTagByFile(it))
      return true;
  }
  return false;
}

void CCommands::selectTagByName(HTREEITEM hParent,LPCTSTR nName)
{
  for(ItemIterator it((TagsListDP*)m_dlgs[_dlgTags],hParent);it;it++)
	{
    if(it.get() && 
//       (it->kind==TAG_CLASS || it->kind==TAG_STRUCT || it->kind==TAG_INTERFACE) &&
       it->m_name==nName)
    {
      throw HTREEITEM(it);
    }
    selectTagByName(it,nName);
  }
}

STDMETHODIMP CCommands::FindAndAddHeader()
{
	return Findclass(true);
}

STDMETHODIMP CCommands::FindClass()
{
	return Findclass(false);
}

STDMETHODIMP CCommands::Findclass(bool addHeader)
{
  if(!LockState::CanDo()) return S_OK;

  AFX_MANAGE_STATE(AfxGetStaticModuleState())
  LockState lock(m_pApplication);

  CString className;

  CComQIPtr<ITextSelection, &IID_ITextSelection> pSel;
  GetSelection(pSel);
	if(pSel)
	{
		BSTR bstrText;
		pSel->get_Text(&bstrText);
    className = bstrText;
  }

  RegularExpression from((const char*)className);
  RegularExpression::CaseSensitive = true;
  if(className.IsEmpty())
  {
    CSelectClassNameDP dlg;
    COleDataObject dataObject;
    if(dataObject.AttachClipboard())
    {
      if(dataObject.IsDataAvailable(CF_TEXT))
      {
        HGLOBAL hObjDesc = dataObject.GetGlobalData(CF_TEXT);
        ASSERT(hObjDesc);
        dlg.className = (char far*)::GlobalLock(hObjDesc);
        ::GlobalUnlock(hObjDesc);
      }
/*      else if(COleClientItem::CanCreateFromData(&dataObject))
      {
      }
*/
    }
    if(dlg.DoModal()!=IDOK)
      return S_OK;

    RegularExpression::CaseSensitive = dlg.m_Case ? true : false;
    if(dlg.m_Begin)
      dlg.className = "^" + dlg.className;
    from = dlg.className;
  }
  if(TagFile.classes.isEmpty())
    DoUpdateInfo(false);

  int res = findTag(TagFile.classes,from);
  if(res==0)
    AfxMessageBox("Can't find declaration");
  if(res==1 || res==-1)
  {

    if(!addHeader)
      SimpleOpenDoc(foundTag->getFile(),foundTag->getLine());
    else
      AddHeader(foundTag->getFile(),foundTag->getLine());
  }
  if(res>1)
    AfxMessageBox("Look in Macros Window");
	return S_OK;
}


STDMETHODIMP CCommands::ToggleFiles()
{
  LockState lock(m_pApplication);
  string strFullPath = GetCurrentFile();
  static string extensions[6] = {".rc",".rc",".hpp",".cxx",".h",".cpp"};
  for(int i=0;i<3;i++)
    for(int j=0;j<2;j++)
      if(replace(strFullPath,extensions[i*2+(1-j)],extensions[i*2+j]))
        return OpenFile(strFullPath.c_str());
	return S_OK;
}

STDMETHODIMP CCommands::OpenFile(LPCTSTR filename)
{
  CComPtr<IGenericDocument> pDoc;
  FindDoc(filename, pDoc,true,"Text");
  return S_OK;
}

BEGIN_MESSAGE_MAP(MyCwnd,CWnd)
 ON_WM_ACTIVATEAPP()
 ON_WM_ENABLE()
 ON_WM_NCPAINT()
END_MESSAGE_MAP()              

void MyCwnd::OnNcPaint()
{
  static lock=false;
  if(!lock)
  {
    lock = true;
    CWnd::OnNcPaint();
  }
  lock=false;
}

void MyCwnd::OnEnable(BOOL bEnable)
{
}

void MyCwnd::OnDestroy()
{
	CWnd::OnDestroy();
  KillTimer(m_timerID);
}


void MyCwnd::PreSubclassWindow()
{
  SetTimer(m_timerID,1500,NULL);
  CWnd::PreSubclassWindow();
}

void MyCwnd::OnActivateApp( BOOL bActive, HTASK hTask )
{
   if(/*m_bIsSubclassed &&*/ CCommands::Get() && bActive==false && CCommands::getValue("AutoSave",0))
     CCommands::Get()->FileSaveAll();
}

HRESULT CCommands::WindowsManager()
{
  if(!LockState::CanDo()) return S_OK;
 	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  toggleDialog(new CDlgWinMgr(m_dirList),_dlgWindows,IDD_DLGWINMGR);
  return S_OK;
}

void CCommands::NeedToDestroy(CDlgMgr* dlg)
{
  if(dlg)
  {
    dlg->DestroyWindow();
    GetDevWnd(); // for activate MSDEV
  }
  delete dlg;
  for(int i=0;i<_dlgCount;i++)
    if(m_dlgs[i]==dlg)
      m_dlgs[i] = 0;
}

void CCommands::ClearVectors()
{
  TagFile.classes.clear();
  TagFile.childrens.clear();
  TagFile.m_files.clear();
}

void CCommands::SetInfo(CComQIPtr<IGenericDocument, &IID_IGenericDocument>& pDocument, bool fDoExtras /* = true*/)
{
	BSTR bstrName;
	pDocument->get_FullName(&bstrName);
	CString strFile,strDir = bstrName;
  baseFilename(strDir,strFile,strDir);
  CFileItem* pFileItem = findFileItem(pDocument);
  if(pFileItem)
  {
		pFileItem->Touch();
    return;
	}
	m_dirList.push_back(new CFileItem(strDir,strFile));
	if(fDoExtras && getValue("AutoDir",1))
    m_pApplication->put_CurrentDirectory(CHAR2BSTR(strDir));
}

void CCommands::OpenDoc(LPCTSTR szFile, IGenericDocument **ppDocRet /* = NULL*/)
{
	CComPtr<IGenericDocument> pDoc;
	if (ppDocRet)
		*ppDocRet = NULL;
	FindDoc(szFile, pDoc);
	if (pDoc)
	{
    VERIFY_OK(pDoc->put_Active((VARIANT_BOOL)VARIANT_TRUE));
		if (ppDocRet)
		{
 			 *ppDocRet = pDoc.p;
			(*ppDocRet)->AddRef();
		}
    if(getValue("AutoDir",1))
    {
      CString filePath,fileName,strFile = szFile;
      baseFilename(strFile,fileName,filePath);
      m_pApplication->put_CurrentDirectory(CHAR2BSTR(filePath));
    }
	}
}

void CCommands::CloseDoc(LPCTSTR szFile)
{
	CComPtr<IGenericDocument> pDoc;
	DsSaveStatus iSaved;
	CComVariant varSaveChanges = dsSaveChangesPrompt;

  FindDoc(szFile, pDoc, false);
	if (pDoc)
		VERIFY_OK(pDoc->Close(varSaveChanges, &iSaved));
}

void CCommands::FindDoc(LPCTSTR szFile, CComPtr<IGenericDocument>& pDoc, bool fOkToOpen /*= true*/,LPCTSTR docType)
{
  CComQIPtr<IDocuments, &IID_IDocuments> pDocuments;
  GetDocuments(pDocuments);

	if (pDocuments)
	{	
		if (fOkToOpen)
		{
		  CComVariant vtDocType = docType;
      CComVariant vtBoolReadOnly = false;
  		CComPtr<IDispatch> pDispDoc;
			pDocuments->Open(CHAR2BSTR(szFile), vtDocType, vtBoolReadOnly, &pDispDoc);
			CComQIPtr<IGenericDocument, &IID_IGenericDocument> pDocument = pDispDoc;
			if(pDocument)
			{
				pDoc = pDocument;
        return;
			}
		}

    for(DocIterator it(pDocuments);it;it++)
    {
			BSTR bstrFullName;
      if(S_OK==it->get_FullName(&bstrFullName))
      {
  			if(wcscmp(bstrFullName,CHAR2BSTR(szFile))==0)
  			{
  				pDoc = it;
          return;
        }
      }
    }
	}
}


STDMETHODIMP CCommands::Options()
{
  if(!LockState::CanDo()) return S_OK;
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  LockState lock(m_pApplication);

  COptionsSheet dlgS;
  dlgS.m_extendedPage.m_Subclass  = getValue("Subclass",0);
  dlgS.m_extendedPage.m_AutoSave  = getValue("AutoSave",0);
  dlgS.m_extendedPage.m_DontRun   = getValue("DontRun",0);

  dlgS.m_windowsPage.m_CheckTime = getValue("Time",1);
	dlgS.m_windowsPage.m_CheckExt  = getValue("Extension",1);
  dlgS.m_windowsPage.m_CheckDir  = getValue("Directory",1);
  dlgS.m_windowsPage.m_AutoDir   = getValue("AutoDir",1);
	
  dlgS.m_tagsPage.m_FilesH       = getValue("SearchHeader",1);
  dlgS.m_tagsPage.m_FilesCPP     = getValue("SearchSource",1);
  dlgS.m_tagsPage.m_UpdateType   = getValue("UpdateType",0);
  dlgS.m_tagsPage.m_ParseCommon  = getValue("ParseCommon",1);
  dlgS.m_tagsPage.m_Regular      = getValue("Regular",0);
  for(int i=0; i<TAG_COUNT;i++)
    dlgS.m_tagsPage.include[i] = getValue(GetFind(i),1);

  if(dlgS.DoModal()==IDOK)
  {
     setValue("Subclass",dlgS.m_extendedPage.m_Subclass);
     setValue("AutoSave",dlgS.m_extendedPage.m_AutoSave);
     setValue("DontRun",dlgS.m_extendedPage.m_DontRun);

     setValue("Time",dlgS.m_windowsPage.m_CheckTime);
	   setValue("Extension",dlgS.m_windowsPage.m_CheckExt);
     setValue("Directory",dlgS.m_windowsPage.m_CheckDir);
     setValue("AutoDir",dlgS.m_windowsPage.m_AutoDir);
	  
     setValue("SearchHeader",dlgS.m_tagsPage.m_FilesH);
     setValue("SearchSource",dlgS.m_tagsPage.m_FilesCPP);
     setValue("UpdateType",dlgS.m_tagsPage.m_UpdateType);
     setValue("ParseCommon",dlgS.m_tagsPage.m_ParseCommon);
     setValue("Regular",dlgS.m_tagsPage.m_Regular);
     for(int i=0; i<TAG_COUNT;i++)
       setValue(GetFind(i),dlgS.m_tagsPage.include[i]);
  }

  return S_OK;
}

STDMETHODIMP CCommands::TagsManager()
{
  if(!LockState::CanDo()) return S_OK;
  LockState lock(m_pApplication);
  AFX_MANAGE_STATE(AfxGetStaticModuleState())

  if(TagFile.classes.isEmpty())
    DoUpdateInfo(false);

  if(!m_dlgs[_dlgTags])
  {
    m_dlgs[_dlgTags] = new TagsListDP();
    BOOL ret = m_dlgs[_dlgTags]->Create(IDD_TAGSDLG,GetDevOrMyWnd());
    if(!ret)
    {
  	  AfxMessageBox("Can't open dialog.\nMay be AddFlow.ocx haven't been registered.\nPlease visit zmanagers.chat.ru for details.");
    	return S_OK;
    }                                                        
  }

  CString nowFile = GetCurrentFile();
  nFile = TagFile.getFileIndex((const char*)nowFile);
  nline = GetCurrentLine();
  selectTagByFile();
  m_dlgs[_dlgTags]->ShowWindow(SW_SHOW);
 	return S_OK;
}

bool CCommands::selectTagByFile()
{
   selected = 0;
   sline = -1;
   selectTagByFile(TVI_ROOT);
   return ((TagsListDP*)m_dlgs[_dlgTags])->openSelected(selected);
}

void CCommands::selectTagByName(LPCTSTR name)
{
   try
   {
     selectTagByName(TVI_ROOT,name);
   }
   catch(HTREEITEM i)
   {
     ((TagsListDP*)m_dlgs[_dlgTags])->openSelected(i);
   }
}


STDMETHODIMP CCommands::Favorites()
{
  //testParse();
  //return S_OK;

  if(!LockState::CanDo()) return S_OK;
  LockState lock(m_pApplication);
  AFX_MANAGE_STATE(AfxGetStaticModuleState())
  toggleDialog(new CDlgFavorites,_dlgFav,IDD_DLGWINMGR);
 	return S_OK;
}

void Run(CString& rstrCmd)
{
  try
	{
      CCommands::Get()->m_run.WriteToPipe(rstrCmd+"\r\n",false);
  }
  catch(...)
  {
  }
}

void BuildThread::run()    
{
  while(!ce_tou)
  {
    //if(!CCommands::Get())
      //suspend();
    //if(!started)
      //continue;

    AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CCommands::Get()->FileSaveAll();


    CFileFind finder;
    VERIFY(finder.FindFile(CCommands::DSWPath+"*.dsw"));
    VERIFY(!finder.FindNextFile());

 	  CComPtr<IDispatch> pDispConfig;
	  CCommands::Get()->GetApplication()->get_ActiveConfiguration(&pDispConfig);
    CComQIPtr<IConfiguration, &IID_IConfiguration> pConfig(pDispConfig);
    if(pConfig)
    {
  	  BSTR bstrConfig;
      pConfig->get_Name(&bstrConfig);
      CString strConfig = bstrConfig;
      int ind = strConfig.ReverseFind(_T('-'));
	    if (ind >= 0)
		    strConfig = strConfig.Mid(ind-1);

      CString rstrCmd1,rstrCmd2;

      rstrCmd1 = rstrCmd2 = "msdev \"" +finder.GetFilePath() + "\" /make ";
      bool r1=false,r2=false;
      for(RegIterator it2(RegBuild+CCommands::CurrentWorkSpace);it2;it2++)
      {
        CString str = " \"" + CString(it2) + strConfig + "\"";
	      if(it2.value()==2)
        {
          r1 = true;
          rstrCmd1 += str;
        }
        else
        {
          r2 = true;
          rstrCmd2 += str;
        }
      }
      rstrCmd1 += _T(" /REBUILD /NORECURSE");
      rstrCmd2 += _T(" /NORECURSE");
      if(r1)  Run(rstrCmd1);
      if(r2)  Run(rstrCmd2);
    }

    if(CCommands::getValue("DontRun",0)==0)
      CCommands::Get()->GetApplication()->ExecuteCommand(CHAR2BSTR("DebugGo"));

    suspend();
  }
}

STDMETHODIMP CCommands::BuildRun()
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState())

  static bool running = false;
  if(running)
  {
	  AfxMessageBox("Build in progress");
    return S_OK;
  }
  running = true;
  gBuild.resume();
  running = false;

  return S_OK;
}

STDMETHODIMP CCommands::UpdateInfo()
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState())
  DoUpdateInfo(true);
  return S_OK;
}

STDMETHODIMP CCommands::SessionManager()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  toggleDialog(new CDlgSessMgr,_dlgSess,IDD_DLGWINMGR);
	return S_OK;
}

STDMETHODIMP CCommands::ShowFileTags()
{
  if(!LockState::CanDo()) return S_OK;
 	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  if(TagFile.classes.isEmpty())
    DoUpdateInfo(false);
  nFile = TagFile.getFileIndex((const char*)GetCurrentFile());
  toggleDialog(new CTagsOfFileMgr,_dlgFileTags,IDD_DLGWINMGR);
  return S_OK;
}

void CCommands::refresh(CCommands::Dlgs d)
{
  if(m_dlgs[d])
    m_dlgs[d]->OnRefresh();
}

void CCommands::RefreshBookMarks()
{
  refresh(_dlgBookMarks);
}

STDMETHODIMP CCommands::PushMark()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  CDlgBookMgr::Push();
  CCommands::Get()->RefreshBookMarks();
	return S_OK;
}

STDMETHODIMP CCommands::PopMark()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  CDlgBookMgr::Pop();
	return S_OK;
}

STDMETHODIMP CCommands::Bookmarks()
{
  if(!LockState::CanDo()) return S_OK;
 	AFX_MANAGE_STATE(AfxGetStaticModuleState())
  toggleDialog(new CDlgBookMgr,_dlgBookMarks,IDD_DLGWINMGR);
  return S_OK;
}

void CCommands::toggleDialog(CDlgMgr* newDlg,CCommands::Dlgs d,int id)
{
  if(CDlgMgr* dlg = m_dlgs[d])
  {
    CCommands::Get()->NeedToDestroy(dlg);
    delete newDlg;
  }
  else
  {
    (m_dlgs[d] = dlg = newDlg)->Create(id,CCommands::Get()->GetDevOrMyWnd());
    dlg->ShowWindow(SW_SHOW);
    //dlg->m_ttip.AddTool(dlg,"tip");
  }
}


void CCommands::OnNewExclude(const char* str,bool isBeforeClass)
{
  RegKey rootKey(AfxGetApp()->GetAppRegistryKey(),!isBeforeClass ? RegExclude : RegExcludeClass);
  RegValue val(rootKey,str);
  val = "";
}

void CCommands::AddMFCExcludeTags()
{
  const struct TagsNames
  {
    char* tag;
    bool  before;
  }
  tags[] =
  {
    "BEGIN_MESSAGE_MAP",false,
    "ON_NOTIFY",false,
    "CLASS_ID",false,
    "ON_BN_CLICKED",false,
    "ON_UPDATE_COMMAND_UI",false,
    "ON_COMMAND",false,
    "IMPLEMENT_DYNAMIC",false,
    "ON_EN_CHANGE",false,
    "IMPLEMENT_DYNCREATE",false,
    "ON_CBN_SELENDOK",false,
    "ON_LBN_SELCHANGE",false,
    "ON_MESSAGE",false,
    "BEGIN_INTERFACE_MAP",false,
    "DECLARE_INTERFACE_",false,
    "SQLOLE_HELPID",false,
    "STDMETHODIMP_",false,
    "uuid",false,
    "INTERFACE_PART",false,
    "DECLARE_MAPI_INTERFACE_",false,
    "_CRTIMP1",true,
    "_CRTIMP",true,
    "COMMMSTVEXPORT",true,
    "DLLEXPORT",true,
    "ATL_NO_VTABLE",true,
    "AFX_NOVTABLE",true,
    "AFXAPI",true,
  };
  for (int i=0; i<sizeof(tags)/sizeof(tags[0]); i++)
    OnNewExclude(tags[i].tag,tags[i].before);
}

void ReadParams::addText(const TCHAR* str)
{
  CCommands::Get()->GetApplication()->PrintToOutputWindow(CHAR2BSTR(str));
}

// next 2 functions using Jignesh Patel sources

void CCommands::AddBookMarks()
{
  CComQIPtr<ITextSelection, &IID_ITextSelection> pTextSel;
  GetSelection(pTextSel);
  if(!pTextSel)
		return;

  CDlgBookMgr::RemoveAllFromFile(GetCurrentFile());

	long nCurrentLine,nCurrentCol;
	pTextSel->get_CurrentLine(&nCurrentLine);
	pTextSel->get_CurrentColumn(&nCurrentCol);

	pTextSel->StartOfDocument(CComVariant(dsMove));
	VARIANT_BOOL var2;
	pTextSel->NextBookmark(&var2);

  std::set<long> arrayLineNumbers;
	while(var2 == VARIANT_TRUE)
	{
		//	Ok, the way bookmarks work is that, if once the bookmark is found 
		//	calling NextBookMark will go / stay at the same line and var2 will
		//	always be TRUE hence, we need to keep a count for ourselves.
  	long nLine;
		pTextSel->get_CurrentLine(&nLine);

	  if(arrayLineNumbers.find(nLine)!=arrayLineNumbers.end())	//	We've gone round or there is only one bookmark.
	  {
			pTextSel->MoveTo(nCurrentLine, nCurrentCol, CComVariant(dsMove));
			return;
		}
		arrayLineNumbers.insert(nLine);

    CDlgBookMgr::Push();
		pTextSel->NextBookmark(&var2);
	}

	pTextSel->MoveTo(nCurrentLine, nCurrentCol, CComVariant(dsMove));
}


void CCommands::SetBookMarks()
{
  CComQIPtr<ITextSelection, &IID_ITextSelection> pTextSel;
  GetSelection(pTextSel);
  if(!pTextSel)
		return;

	//	Check to see if something is highlighted or not.
	CComBSTR bstrSelectionText;
	pTextSel->get_Text(&bstrSelectionText);
	bool bIsTextSelected = !!bstrSelectionText;

  long nCurrentLine,nCurrentCol;
  pTextSel->get_CurrentLine(&nCurrentLine);
	pTextSel->get_CurrentColumn(&nCurrentCol);

  CDlgBookMgr::RefreshFile(GetCurrentFile());
		
	//	Position the cursor to original position.
	//	If something is highlighted, most probably it'll be the whole line.
	if(bIsTextSelected)
	{
		pTextSel->GoToLine(nCurrentLine,CComVariant(dsMove));
		pTextSel->SelectLine();
	}
	else
		pTextSel->MoveTo(nCurrentLine, nCurrentCol, CComVariant(dsMove));
}


void CCommands::SetBookmark(int line)
{
  CComQIPtr<ITextSelection, &IID_ITextSelection> pSel;
  GetSelection(pSel);
  if(pSel)
  {
    if(line>=0)
		  pSel->GoToLine(line,CComVariant(dsMove));

    pSel->SetBookmark();
  }
}

void CCommands::ClearBookmark(CString s, int line)
{
  CString curFile = GetCurrentFile();  // remember current file

 	CComPtr<IGenericDocument> doc;
  FindDoc(s,doc,false); // try to find new file
  if(doc)
  {
    FindDoc(s,doc,true); // open new file
    GoToLine(line);

    CComQIPtr<ITextSelection, &IID_ITextSelection> pSel;
    GetSelection(pSel);
    if(pSel)
    {
      VARIANT_BOOL pbRet;
      pSel->ClearBookmark(&pbRet); // remove bookmark
    }
                                         
    FindDoc(curFile,doc,true); // open old file
  }
}