// DlgFavorites.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#include "stdafx.h"
#include <afxdlgs.h>        

#include "resource.h"       
#include "Commands.h"       
#include "DlgFavorites.h"
#include "Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CDlgFavorites dialog

CDlgFavorites::CDlgFavorites() : m_ctlListFavorites(this)
{
  avalibleCommands=AllCommnads;
}

void CDlgFavorites::DoDataExchange(CDataExchange* pDX)
{
	CDlgMgr::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFavorites)
	DDX_Control(pDX, IDC_LIST, m_ctlListFavorites);
	//}}AFX_DATA_MAP
}


/////////////////////////////////////////////////////////////////////////////
// CDlgFavorites message handlers

BOOL CDlgFavorites::OnInitDialog()
{
	CDlgMgr::OnInitDialog();

	m_ctlListFavorites.makeColumns("",0);
  m_ctlListFavorites.ModifyStyle(0,LVS_NOCOLUMNHEADER);

	FillList();
  return true;
}

void CDlgFavorites::FillList()
{
	m_ctlListFavorites.DeleteAllItems();

  for(RegIterator it(RegFavorites+CCommands::CurrentWorkSpace);it;it++)
    m_ctlListFavorites.InsertItem(int(it),CString(it),NULL);

  m_ctlListFavorites.SetWidths();

  UpdateData(false);
}

void CDlgFavorites::OnOK()
{
  OnSelect(m_ctlListFavorites);
}

void CDlgFavorites::OnSelect(CMListCtrl& ctrl)
{
  CString fullPath(RegFavorites+CCommands::CurrentWorkSpace);
	for( CListSelIterator iter(ctrl);iter;)
	{
		CString strDoc = m_ctlListFavorites.GetItemText(iter,0);
  	CComPtr<IGenericDocument> doc;
    CCommands::Get()->FindDoc(CCommands::getValue(strDoc,"",fullPath),doc);
	}
  CDlgMgr::OnSelect(ctrl);
}

void CDlgFavorites::OnDel()
{
  CString fullPath(RegFavorites+ CCommands::CurrentWorkSpace);
  for( CListSelIterator iter(m_ctlListFavorites);iter;)
	{
		CString strDoc = m_ctlListFavorites.GetItemText(iter,0);
    DeleteValue(fullPath,strDoc);
	}
  FillList();
}

void CDlgFavorites::OnInsert()
{
  CString activeName = CCommands::Get()->GetCurrentFile();
  CString activeShortName = activeName;
  baseFilename(activeName,activeShortName,CString());
  SetValue(RegFavorites+CCommands::CurrentWorkSpace,activeShortName,activeName);
  FillList();
}
