// DlgWinMgr.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#include "stdafx.h"
#include <afxdlgs.h>
#include "Commands.h"
#include "DlgMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IDlg dialog

int CALLBACK IDlg::MySort(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
//	_ASSERTE(lParam1 && lParam2);
  IDlg* _this = (IDlg*)lParamSort;
	int iComp = _this->Sort(lParam1,lParam2);
	return iComp;
}

void IDlg::OnSelect(CMListCtrl& ctrl)
{
  if(CCommands::getValue(getName()+"AutoClose",1))
    OnESC();
  else
    SelectCurrent();
}

/////////////////////////////////////////////////////////////////////////////
// CDlgMgr dialog
CDlgMgr::CDlgMgr(int idd): CDialog(idd),avalibleCommands(0)
{
}

BEGIN_MESSAGE_MAP(CDlgMgr, CDialog)
	//{{AFX_MSG_MAP(CDlgMgr)
  ON_WM_NCPAINT()
  ON_WM_NCLBUTTONDOWN() 
	ON_WM_NCLBUTTONUP()
  ON_WM_NCMOUSEMOVE()

  ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_NCACTIVATE()
  ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CDlgMgr::OnInitDialog()
{
  CDialog::OnInitDialog();

  static struct Items
  {
    char* str;
    char* tip; 
  }
  items[] = 
  {
    {"","Toggle auto close"},
    //{"","Enter"}, // 
    {"1","Add new item <Ins>"},  // 
    {"","Delete item <Del>"},   // (\" )
    {"","Select all <Ctrl+A>"}, //(4)
    {"6","Synchronize"},             //
  };


  int curCom = 0x01;
  for(int i=0;i<sizeof(items)/sizeof(items[0]);i++)
  {
    Commnad com = curCom&avalibleCommands ? Commnad(curCom) : Disabled;
    m_items.push_back(CommandItem(items[i].str,com,items[i].tip));
    curCom <<= 1;
  }

  m_font.createPointFont(80);
  
  CString str = getName();
  SetWindowText(str);                                    

  m_items[0].m_checked = CCommands::getValue(str+"AutoClose",1) ? 0 : 1;
  int x  = CCommands::getValue(str+"Left",100);
  int y  = CCommands::getValue(str+"Top",100);
  int dx = CCommands::getValue(str+"Width",500);
  int dy = CCommands::getValue(str+"Heigth",500);

  MoveWindow(x,y,dx,dy);

	m_ttip.Create(this);

	TOOLINFO ti;
	memset(&ti, 0, sizeof(TOOLINFO));
	ti.cbSize = sizeof(TOOLINFO);
  ti.hwnd = m_hWnd;
	ti.uFlags = TTF_IDISHWND;
	ti.uId = (UINT)m_hWnd;
	m_ttip.SendMessage(TTM_ADDTOOL, 0, (LPARAM)&ti);

  m_ttip.Activate(TRUE);

  return TRUE;
}

void CDlgMgr::OnESC()             
{
  CCommands::Get()->NeedToDestroy(this);
}

void CDlgMgr::OnClose()
{
  OnESC();
}

void CDlgMgr::savePos()
{
  CString str = getName();
  CRect rc;
  GetWindowRect(&rc);
  CCommands::setValue(str+"Left",rc.left);
  CCommands::setValue(str+"Top",rc.top);
  CCommands::setValue(str+"Width",rc.Width());
  CCommands::setValue(str+"Heigth",rc.Height());
}

void CDlgMgr::OnDestroy()
{
  savePos();
  CDialog::OnDestroy();
}

BOOL CDlgMgr::OnNcActivate(BOOL bActive)
{
  // If you want different look when inactive change this
  CDialog::OnNcActivate(bActive);
  OnNcPaint(); 
  if(!bActive)
    savePos();
  return TRUE; 
}

void CDlgMgr::OnSize( UINT f, int cx, int cy )
{
  CDialog::OnSize(f, cx, cy); // don't allow to scroll page

#ifdef _DEBUG
  CWnd* wnd0 = GetTopWindow();
  int count = 0;
  do  count++; while((wnd0 = wnd0->GetNextWindow()));
  ASSERT(count==1);
#endif

  CRect rc;
  GetClientRect(&rc);
  GetTopWindow()->MoveWindow(0,0,rc.Width(),rc.Height());
}

CRect CDlgMgr::GetRect(int i)
{
    CRect closeRect;
    closeRect.left = 140 + i*25;
    closeRect.top = 1 + GetSystemMetrics(SM_CYFRAME);
    closeRect.right = closeRect.left + 20;
    closeRect.bottom = 1 + GetSystemMetrics( SM_CYSIZE );
    return closeRect;
}

int CDlgMgr::HitTest(CPoint point)
{
	// Coords are relative to screen
	CPoint pt=point;
	// Convert for relative to client area
	ScreenToClient(&pt);

  // Adjust for client area
	pt.y += GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME);
	pt.x += 5;

	// Check for buttons
  for(int i=0;i<m_items.size();i++)
  {
	  if(GetRect(i).PtInRect(pt))
		  return i;
  }
  return -1;
}

void CDlgMgr::OnNcPaint() 
{
  // If you only change the menu bar, let the framework draw 
	// the window first
	Default();
  DrawAllItems();
}

void CDlgMgr::OnNcLButtonDown(UINT nHitTest, CPoint point) 
{ 
	// Now test for button
	int  hitTest = HitTest(point);
	if(hitTest>=0)
	{
    m_items[hitTest].m_pressed = true;
    DrawAllItems();
	}
  else
  {
		Default(); 
  }
} 

void CDlgMgr::OnNcLButtonUp(UINT nFlags, CPoint point) 
{
	// Coords are relative to window now
	int  hitTest = HitTest(point);

  if(hitTest>=0)
  {
    m_items[hitTest].m_pressed = false;
	  switch(m_items[hitTest].id)		// Process command if released at on a button
	  {
	    case AutoClose:
        CCommands::setValue(getName()+"AutoClose",1-CCommands::getValue(getName()+"AutoClose",1));
        m_items[0].m_checked = CCommands::getValue(getName()+"AutoClose",1) ? 0 : 1;
  	  break;
	    case Insert:
        OnInsert();
			  break;
	    case Delete:
        OnDel();
			  break;
	    case SelectAll:
        OnSelectAll();
			  break;
	    case Synchronize:
        OnSynchronize();
			  break;
	    default:
			  break;
	  }
  }
  OnNcPaint();
  OnNcMouseMove(0,point);
}

void CDlgMgr::OnNcMouseMove(UINT nHitTest, CPoint point) 
{
  int  hitTest = HitTest(point);

	if(hitTest>=0 && m_items[hitTest].m_selected)
  {
		CDialog::OnNcMouseMove(nHitTest,point);
    return;
  }

  for(int i=0;i<m_items.size();i++)
    m_items[i].m_selected = false;
  
  if(hitTest>=0)
  {
    m_items[hitTest].m_selected = true;

    TOOLINFO ti;
	  memset(&ti, 0, sizeof(TOOLINFO));
	  ti.cbSize = sizeof(TOOLINFO);
    ti.hwnd = m_hWnd;
	  ti.uFlags = TTF_IDISHWND;
	  ti.uId = (UINT)m_hWnd;
	  ti.lpszText = m_items[hitTest].tip;

    m_ttip.SetToolInfo(&ti);

    RelayEvent(WM_MOUSEMOVE,point);
  }
  else
  {
    RelayEvent(WM_LBUTTONDOWN,point);
  }

  DrawAllItems();
	
  CDialog::OnNcMouseMove(nHitTest,point);
}

void CDlgMgr::DrawAllItems()
{
  for(int i=0;i<m_items.size();i++)
    DrawItem(i);
}
void CDlgMgr::DrawItem(int item) 
{
  COLORREF NormalColor          = RGB(200,200,200);
  COLORREF DisableColor        = RGB(28,28,28);
  COLORREF CheckedColor        = RGB(200,0,0);
  COLORREF FocusColor          = RGB(255,255,255);
  COLORREF FocusChechedColor   = RGB(255,0,0);
  COLORREF PresedColor         = RGB(0  ,255,0);

  COLORREF textColor = NormalColor;

	CWindowDC dc(this);
  if(m_items[item].m_selected)
    textColor = FocusColor;
  if(m_items[item].m_pressed)
    textColor = PresedColor;
  if(m_items[item].m_checked)
  {
    textColor = CheckedColor;
    if(m_items[item].m_selected)
      textColor = FocusChechedColor;
    if(m_items[item].m_pressed)
      textColor = PresedColor;
  }
  if(m_items[item].m_disable)
  {
    textColor = DisableColor;
  }
  dc.SetTextColor(textColor);
  CNestorLockBkMode lockBb(dc,TRANSPARENT);
  CNestorLockFont lock(dc,m_font);
  dc.DrawText(m_items[item].str,&GetRect(item),DT_CENTER|DT_VCENTER);
}

void CDlgMgr::RelayEvent(UINT message, CPoint point)
{
	// This function will create a MSG structure, fill it in a pass it to
	// the ToolTip control, m_ttip.  Note that we ensure the point is in window
	// coordinates (relative to the control's window).
	MSG msg;
	msg.hwnd = m_hWnd;
	msg.message = message;
	msg.wParam = 0;
	msg.lParam = MAKELPARAM(LOWORD(point.x), LOWORD(point.y));
	msg.time = 0;
	msg.pt.x = point.x;
	msg.pt.y = point.y;

	m_ttip.RelayEvent(&msg);
}
