#if !defined(AFX_DLGMGR_H__C1AC212C_8ABF_11D1_B145_000000000000__INCLUDED_)
#define AFX_DLGMGR_H__C1AC212C_8ABF_11D1_B145_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgMgr.h : header file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#include <afxext.h>
#include "NestorGDI.h"

#include <vector>

class CMListCtrl;

class IDlg
{
 public:

  static int CALLBACK MySort(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

  virtual void OnSelect(CMListCtrl& ctrl);
  virtual void OnInsert() {ASSERT(false);} 
  virtual void OnDel() {ASSERT(false);}
  virtual void OnSelectAll() {ASSERT(false);}
  virtual void OnESC() {ASSERT(false);}

 protected:
  virtual void SelectCurrent() {}

  virtual CString getName() {return "Error";}

	/*
			The comparison function must return a negative value
			if the first item should precede the second, a positive
			value if the first item should follow the second, or
			zero if the two items are equivalent.
	*/
  virtual int Sort(LPARAM lParam1, LPARAM lParam2){ return 0;}

};


/////////////////////////////////////////////////////////////////////////////
// CDlgMgr dialog

class CDlgMgr : public CDialog, public IDlg
{
// Construction
public:
  CDlgMgr() {};
	CDlgMgr(int idd);
  ~CDlgMgr() {}

//  virtual void OnCancel() {DestroyWindow();}

  virtual void OnRefresh() {ASSERT(false);}
  virtual void OnSynchronize(){ASSERT(false);}

  using CDialog::UpdateData;
  using CDialog::ShowWindow;

protected:
	DECLARE_MESSAGE_MAP()
  void OnSize( UINT f, int cx, int cy );
  void OnClose();
  void OnDestroy();
  BOOL OnNcActivate(BOOL);

  void OnNcPaint();
  void OnNcLButtonDown(UINT nHitTest, CPoint point);
  void OnNcLButtonUp(UINT nFlags, CPoint point);
  void OnNcMouseMove(UINT nHitTest, CPoint point );

  virtual void OnESC();

 // virtual void PostNcDestroy() {delete this;}

  virtual BOOL OnInitDialog();
  
  // tool tips
  void RelayEvent(UINT message,CPoint point);
  
  enum Commnad
  {
    Disabled     = 0x00,
    AutoClose    = 0x01,
    Insert       = 0x02,
    Delete       = 0x04,
    SelectAll    = 0x08,
    Synchronize  = 0x10,
    AllCommnads  = AutoClose |Insert | Delete | SelectAll,
    AllCommnads2 = AllCommnads | Synchronize,
    //LastCommand = SelectAll,
  };

  int avalibleCommands;
 private:

   void DrawItem(int item);

  struct CommandItem
  {
    CommandItem() {}
    CommandItem(char* astr,Commnad aid,char* atip):str(astr),id(aid),tip(atip),
                                                   m_pressed(false),m_selected(false),m_checked(false)
                                                   {m_disable = id==Disabled;}
    char*     str;
    Commnad   id;
    char*     tip; 
    bool      m_pressed;
	  bool      m_selected;
	  bool      m_disable;
	  bool      m_checked;
  };
  std::vector<CommandItem> m_items;
  friend struct CommandItem;

  CToolTipCtrl      m_ttip;
  CNestorFont  m_font;

  void DrawAllItems();
  CRect GetRect(int i);
  int  HitTest(CPoint pt);
  void savePos();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGWINMGR_H__C1AC212C_8ABF_11D1_B145_000000000000__INCLUDED_)
