// DlgWinMgr.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#include "stdafx.h"
#include <afxdlgs.h>

//#include "resource.h"
#include "Commands.h"
#include "DlgsessMgr.h"
#include "DlgWinMgr.h"
#include "Utils.h"
#include "Registry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CDlgSessMgr dialog

CDlgSessMgr::CDlgSessMgr() : m_ctlListWinMgr(this)
{
  avalibleCommands=AllCommnads;
}

void CDlgSessMgr::DoDataExchange(CDataExchange* pDX)
{
	CDlgMgr::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSessMgr)
	DDX_Control(pDX, IDC_LIST, m_ctlListWinMgr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSessMgr, CDlgMgr)
	//{{AFX_MSG_MAP(CDlgSessMgr)
  ON_NOTIFY(LVN_ENDLABELEDIT, IDC_LIST, OnEndLabelEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSessMgr message handlers

BOOL CDlgSessMgr::OnInitDialog()
{
	CDlgMgr::OnInitDialog();

	m_ctlListWinMgr.makeColumns("",0);
  m_ctlListWinMgr.ModifyStyle(0,LVS_NOCOLUMNHEADER|LVS_EDITLABELS);

	FillList();
  return true;
}

void CDlgSessMgr::FillList()
{
	m_ctlListWinMgr.DeleteAllItems();

  for(RegIterator it(RegSessions+CCommands::CurrentWorkSpace,false);it;it++)
		m_ctlListWinMgr.InsertItem(int(it),CString(it), NULL);

  m_ctlListWinMgr.SetWidths();
}

void CDlgSessMgr::OnEndLabelEdit(NMHDR * pNotifyStruct, LRESULT* result )
{
	LV_ITEM *plvItem = &((LV_DISPINFO *)pNotifyStruct)->item;

  RenameSession(m_ctlListWinMgr.GetItemText(plvItem->iItem,0),plvItem->pszText);

	if(plvItem->pszText)
		m_ctlListWinMgr.SetItemText(plvItem->iItem, plvItem->iSubItem, plvItem->pszText);
  *result = 0;
}


void CDlgSessMgr::OnButtonmakelist(vector<CString>& lst,LPCTSTR listName)
{
  CString fullPath(RegSessions + CCommands::CurrentWorkSpace);
  CreateKey(RegSessions + CCommands::CurrentWorkSpace);
  CString section = contact(fullPath,listName);
  int i = 1;
  for(int p=0;p<lst.size();p++)
    CCommands::setValue(GetFile(i++),lst[p],section);
}

void CDlgSessMgr::OnButtonmakelist(LPCTSTR listName)
{
  vector<CString> lst;
  for(list<CFileItem*>::iterator  i = CCommands::Get()->m_dirList.begin();i != CCommands::Get()->m_dirList.end();++i)
    lst.push_back(contact((*i)->m_Dir,(*i)->m_File));
  OnButtonmakelist(lst,listName);
}

void CDlgSessMgr::DeleteSession(CString oldName)
{
  RegKey key(AfxGetApp()->GetAppRegistryKey(),RegSessions+CCommands::CurrentWorkSpace);
  key.NukeKey(oldName);
}

void CDlgSessMgr::RenameSession(CString oldName,CString newName)
{
  if(oldName==newName)
    return;
  vector<CString> list;
  CString fullName(contact(RegSessions+CCommands::CurrentWorkSpace,oldName));
  int i = 1;
  while(true)
  {
    CString strDoc = CCommands::getValue(GetFile(i++),"",fullName);
    if(strDoc.IsEmpty())
      break;
    list.push_back(strDoc);
  }

  OnButtonmakelist(list,newName);
  DeleteSession(oldName);
}

void CDlgSessMgr::OnButtonloadlist(LPCTSTR listName)
{
  vector<CString> list;
  CString fullName(contact(RegSessions+CCommands::CurrentWorkSpace,listName));
  int i = 1;
  while(true)
  {
    CString strDoc = CCommands::getValue(GetFile(i++),"",fullName);
    if(strDoc.IsEmpty())
      break;
		CComPtr<IGenericDocument> pDoc;
		CCommands::Get()->OpenDoc(strDoc, &pDoc);
  }
}

void CDlgSessMgr::OnSelect(CMListCtrl& ctrl)
{
	for( CListSelIterator iter(ctrl);iter;)
    OnButtonloadlist(ctrl.GetItemText(iter,0));
  CDlgMgr::OnSelect(ctrl);
}

void CDlgSessMgr::OnDel()
{
  for( CListSelIterator iter(m_ctlListWinMgr);iter;)
    DeleteSession(m_ctlListWinMgr.GetItemText(iter,0));
  FillList();
}

void CDlgSessMgr::OnInsert()
{
    OnButtonmakelist(CCommands::CurrentSession);
  	FillList();
}

