// MyListCtrl.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#include "stdafx.h"
#include <vector>

using namespace std;

//#include "resource.h"
#include "MListCtrl.h"
#include "DlgsessMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int  PIXEL_PAD = 20;

/////////////////////////////////////////////////////////////////////////////
// CMListCtrl

CMListCtrl::CMListCtrl(IDlg* mgr) : m_mgr(mgr)
{
	m_cCols = 0;
	m_iSortedCol = 0;
}

void CMListCtrl::DoSort()
{
	SortItems((PFNLVCOMPARE)m_mgr->MySort,(LPARAM)m_mgr);
}


BEGIN_MESSAGE_MAP(CMListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CMyListCtrl)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_WM_KEYDOWN()
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CMListCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
  if( nChar  == VK_RETURN) // select
  {
    m_mgr->OnSelect(*this);
    return;
  }
  if( nChar == VK_DELETE) // delete
  {
    m_mgr->OnDel();
    return;
  }
  if( nChar == VK_INSERT) // new
  {
    m_mgr->OnInsert();
    return;
  }
  if( nChar == VK_ESCAPE)
  {
   	m_mgr->OnESC();
    return;
  }
  if((GetKeyState(VK_CONTROL)&0x80) && (nChar == 0x41) /*'A'*/)
  {
    m_mgr->OnSelectAll();
  }
	CListCtrl::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMListCtrl::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult)
{
  m_mgr->OnSelect(*this);
}

void CMListCtrl::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult)
{
	NMLISTVIEW* pNMListView = (NMLISTVIEW*)pNMHDR;

	int iColumn = pNMListView->iSubItem + 1;
	int iColumnLast = m_iSortedCol;
	if (iColumn == abs(iColumnLast)) // a repeat so we switch directions?
	{
		iColumn = -iColumnLast;
	}
	m_iSortedCol = iColumn;

  DoSort();
}


int CMListCtrl::InsertItem(int nItem, LPCTSTR lpszItem, LPARAM lItemData)
{
	if(nItem<0)
	  nItem = GetItemCount();
	CListCtrl::InsertItem(nItem, lpszItem);
	SetItemData(nItem, lItemData);
	return nItem;
}


void CMListCtrl::SetWidths()
{
	for (int j = m_cCols-1; j >= 0; j--)
    SetColumnWidth(j,LVSCW_AUTOSIZE_USEHEADER);
}

void CMListCtrl::InsertColumn(int nCol, LPCTSTR lpszColumnHeading,
		int nFormat /*= LVCFMT_LEFT*/, int nWidth /*= -1*/, int nSubItem /* = -1*/)
{
	m_cCols++;
  int iWidth = nWidth != -1 ? nWidth : GetStringWidth(lpszColumnHeading) + PIXEL_PAD;
	int iRes = CListCtrl::InsertColumn(nCol, lpszColumnHeading, nFormat, iWidth, nSubItem);
}

void CMListCtrl::makeColumns(char* column,...)
{
  int i = 0;
  va_list marker;
  va_start(marker,column);            /* Initialize variable arguments. */
  while(column)
  {
    InsertColumn(i++,column);
    column = va_arg(marker,char*);
  }
  va_end( marker );              /* Reset variable arguments.      */
}

