/*@ NestorGDI.cpp                             Version from  24.02.99 12:42  */
/*                                              Created on  6/10/98 12:35PM */
/* Contents-----------------------------------------------------------------**
**                                                                          **
**                                                                          **
$*                                                                          */
/*--------------------------------------------------------------------------**
** Designed by Melnikov Mike                                               **
** Modified by Anton Riabov.                                                **
** COPYRIGHT (C) 1997-98 by Nestor Crew of Animatek Inc.                    **
** All rights reserved.                                                     **
** -------------------------------------------------------------------------*/
#include "stdafx.h"
#ifndef _NestorGDI_h_
#include "NestorGDI.h"
#endif // _NestorGDI_h_

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   Font class

CNestorFont::CNestorFont()
{
}

CNestorFont::~CNestorFont()
{
}

static char* knownFonts[] = {"Wingdings","Arial","MS Sans Serif"};

bool CNestorFont::createPointFont(int size)
{
  for(int i=0;i<sizeof(knownFonts)/sizeof(knownFonts[0]);i++)
    if (CreatePointFont(100,knownFonts[i]))
      return true;
  return false;
}

CSize CNestorFont::getSize(CString str)
{
  CClientDC clientDC(NULL);
  CFont* pfnt = clientDC.SelectObject(this);
  CSize size = clientDC.GetTextExtent(str,str.GetLength());
  clientDC.SelectObject(pfnt);
  return size;
}


CNestorLockFont::CNestorLockFont(CDC& adc,CFont& font) : dc(adc)
{
  pfnt = dc.SelectObject(&font);
}

CNestorLockFont::~CNestorLockFont()
{
  dc.SelectObject(pfnt);
}


/////////////////////////////////////////////////////////////////////////////
//   Brush class

CNestorLockBrush::CNestorLockBrush(CDC& adc,CBrush& brush) : dc(adc),m_brush(NULL)
{
  pBrush = dc.SelectObject(&brush);
}

CNestorLockBrush::CNestorLockBrush(CDC& adc,COLORREF crColor ) : dc(adc)
{
  m_brush = new CBrush(crColor);
  pBrush = dc.SelectObject(m_brush);
}

CNestorLockBrush::CNestorLockBrush(CDC& adc,int nIndex, COLORREF crColor) : dc(adc)
{
  m_brush = new CBrush(nIndex,crColor);
  pBrush = dc.SelectObject(m_brush);
}

CNestorLockBrush::CNestorLockBrush(CDC& adc,CBitmap* pBitmap ) : dc(adc)
{
  m_brush = new CBrush(pBitmap);
  pBrush = dc.SelectObject(m_brush);
}

CNestorLockBrush::~CNestorLockBrush()
{
  dc.SelectObject(pBrush);
  delete  m_brush; m_brush = NULL;
}

/////////////////////////////////////////////////////////////////////////////
//   Pen class

CNestorLockPen::CNestorLockPen(CDC& adc,CPen& pen) : dc(adc),m_pen(NULL)
{
  pPen = dc.SelectObject(&pen);
}

CNestorLockPen::CNestorLockPen(CDC& adc, int nPenStyle, int nWidth, COLORREF crColor ) : dc(adc)
{
  m_pen = new CPen(nPenStyle,nWidth,crColor);
  pPen = dc.SelectObject(m_pen);
}

CNestorLockPen::CNestorLockPen(CDC& adc,int nPenStyle, int nWidth, const LOGBRUSH* pLogBrush, int nStyleCount, const DWORD* lpStyle) : dc(adc)
{
  m_pen = new CPen(nPenStyle,nWidth,pLogBrush,nStyleCount,lpStyle);
  pPen = dc.SelectObject(m_pen);
}

CNestorLockPen::~CNestorLockPen()
{
  dc.SelectObject(pPen);
  delete  m_pen; m_pen = NULL;
}


/////////////////////////////////////////////////////////////////////////////
//   Bk mode class

CNestorLockBkMode::CNestorLockBkMode(CDC& adc,int newBkMode) : dc(adc)
{
  nBkMode = dc.SetBkMode(newBkMode);
}

CNestorLockBkMode::~CNestorLockBkMode()
{
  dc.SetBkMode(nBkMode);
}
