/*@ NestorThreads.h                           Version from  19.04.99 17:35  */
#ifndef _NestorThreads_h_
#define _NestorThreads_h_

// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru

//=================  Class Thread
class Thread
{
    static unsigned int __stdcall Func(void* );

    DWORD  threadID;
    HANDLE externalHandle;
  public:
    Thread(bool createSuspended = true,int nPriority = THREAD_PRIORITY_NORMAL,bool autoDestroy = false);  //    start
    virtual ~Thread();

    void resume();
    void suspend();
    void wait(DWORD milliseconds = INFINITE);
    void terminate(DWORD exitCode);
    void setPriorityLevel(int );
    void set_auto_destroy(bool aAutoDestroy) { destroyOnExit = aAutoDestroy; }

  protected:
    void exit(DWORD exitCode);
    virtual void run() = 0;

    bool   destroyOnExit;
};

class Timer : public Thread
{
  public:
    Timer();
   
    typedef void(*Call)(void  *user_data);

    void start(float seconds,Call callback,void* user_data=NULL); //      callback

    void reset();                                            //  
    void done();

    bool is_started(){return started;}
    void set_auto_reset(bool  enable)   {auto_reset = enable;}

  protected:
    virtual void run();

    Call   call_me_please;
    bool   ce_tou;
    int    wait_for;
    void*  data_for_call;
    bool   started;
    bool   auto_reset;
};



#endif // _NestorThreads_h_
