#include <clex.h>

/* #line 1 "D:\UsefulManagers_src\Parser\dswlexer.l" */

/****************************************************************************
lexer.l
****************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "dswparser.h"


// repeated because of possible precompiled header
#include <clex.h>

#include "dswlexer.h"

/////////////////////////////////////////////////////////////////////////////
// constructor

YYLEXNAME::YYLEXNAME()
{
	yytables();
/* #line 50 "D:\UsefulManagers_src\Parser\dswlexer.l" */

  assert(false);

}

#ifndef YYTEXT_SIZE
#define YYTEXT_SIZE 100
#endif
#ifndef YYUNPUT_SIZE
#define YYUNPUT_SIZE YYTEXT_SIZE
#endif

// backwards compatability with lex
#ifdef input
int YYLEXNAME::yyinput()
{
	return input();
}
#else
#define input yyinput
#endif

#ifdef output
void YYLEXNAME::yyoutput(int ch)
{
	output(ch);
}
#else
#define output yyoutput
#endif

#ifdef unput
void YYLEXNAME::yyunput(int ch)
{
	unput(ch);
}
#else
#define unput yyunput
#endif

#ifndef YYNBORLANDWARN
#ifdef __BORLANDC__
#pragma warn -rch		// <warning: unreachable code> off
#endif
#endif

int YYLEXNAME::yyaction(int action)
{
/* #line 63 "D:\UsefulManagers_src\Parser\dswlexer.l" */

// extract yylval for use later on in actions
YYSTYPE& yylval = *(YYSTYPE*)yyparserptr->yylvalptr;

	yyreturnflg = 1;
	switch (action) {
	case 1:
		{
/* #line 69 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 return PROJECT; 
		}
		break;
	case 2:
		{
/* #line 70 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 return DEP; 
		}
		break;
	case 3:
		{
/* #line 75 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 /* do nothing*/
		}
		break;
	case 4:
		{
/* #line 76 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 return '\n'; 
		}
		break;
	case 5:
		{
/* #line 78 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 return '\"'; 
		}
		break;
	case 6:
		{
/* #line 80 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 yylval.string = phrase(); return PHRASE; 
		}
		break;
	case 7:
		{
/* #line 83 "D:\UsefulManagers_src\Parser\dswlexer.l" */
 
		}
		break;
	default:
		yyassert(0);
		break;
	}
	yyreturnflg = 0;
	return 0;
}

#ifndef YYNBORLANDWARN
#ifdef __BORLANDC__
#pragma warn .rch		// <warning: unreachable code> to the old state
#endif
#endif
/* #line 85 "D:\UsefulManagers_src\Parser\dswlexer.l" */


/////////////////////////////////////////////////////////////////////////////
// Lexer commands

DswLexer::DswLexer(const char* str)
{
  yytables();
  openFile(str);
}

DswLexer::~DswLexer()
{
  for(int i=0;i<strings.size();i++)
    delete strings[i];
}

/////////////////////////////////////////////////////////////////////////////
// Lexer attribute commands
void DswLexer::openFile(const char* str)
{
  FILE* file = fopen(str,"r");
  if(file)
    m_files.push_back(file);
}
void DswLexer::closeFile()
{
  if(m_files.size())
  {
    fclose(*m_files.rbegin());
    m_files.erase(m_files.end()-1);
  }
}

string* DswLexer::phrase()
{
  string* s = id();
  return s;
}

string* DswLexer::id()
{
  string* p = new string(yytext);
  strings.push_back(p);
  return p;
}


//#define TRACE_AUTOMAT_PARSER 

int DswLexer::yygetchar()
{
  if(!m_files.size())
    return EOF;
  int c = getc(*m_files.rbegin());
#ifdef TRACE_AUTOMAT_PARSER
  char str[2];
  str[0] = c;
  str[1] = 0;
  OutputDebugString(str);
#endif
  switch(c)
  {
    case EOF:
      closeFile(); // retrun \n
    case '\n' :
    case '\r' :
    case ';'  :
     return '\n';
  }
  return c;
}


void YYLEXNAME::yytables()
{
	yystext_size = YYTEXT_SIZE;
	yysunput_size = YYUNPUT_SIZE;

	static const yymatch_t YYNEARFAR YYBASED_CODE match[] = {
		0
	};
	yymatch = match;

	yytransitionmax = 231;
	static const yytransition_t YYNEARFAR YYBASED_CODE transition[] = {
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 4, 1 },
		{ 5, 1 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 4, 1 },
		{ 7, 1 },
		{ 6, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 17, 15 },
		{ 7, 1 },
		{ 7, 1 },
		{ 17, 17 },
		{ 0, 0 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 15, 14 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 3, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 18, 16 },
		{ 7, 1 },
		{ 22, 21 },
		{ 7, 1 },
		{ 7, 1 },
		{ 16, 14 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 7, 1 },
		{ 10, 9 },
		{ 11, 10 },
		{ 12, 11 },
		{ 7, 1 },
		{ 13, 12 },
		{ 14, 13 },
		{ 9, 3 },
		{ 19, 18 },
		{ 20, 19 },
		{ 21, 20 },
		{ 23, 22 },
		{ 24, 23 },
		{ 25, 24 },
		{ 7, 25 },
		{ 0, 0 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 0, 0 },
		{ 7, 25 },
		{ 7, 25 },
		{ 0, 0 },
		{ 0, 0 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 0, 0 },
		{ 7, 25 },
		{ 0, 0 },
		{ 7, 25 },
		{ 7, 25 },
		{ 0, 0 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 7, 25 },
		{ 0, 0 },
		{ 0, 0 },
		{ 0, 0 },
		{ 7, 25 }
	};
	yytransition = transition;

	static const yystate_t YYNEARFAR YYBASED_CODE state[] = {
		{ 0, 0, 0 },
		{ -8, 1, 0 },
		{ 1, 0, 0 },
		{ 25, 16, 6 },
		{ 0, 0, 3 },
		{ 0, 0, 4 },
		{ 0, 0, 5 },
		{ 25, 0, 6 },
		{ 0, 0, 7 },
		{ 25, 13, 6 },
		{ 25, 19, 6 },
		{ 25, 25, 6 },
		{ 25, 29, 6 },
		{ 25, 13, 6 },
		{ 25, 2, 6 },
		{ 25, 8, 1 },
		{ 25, 24, 6 },
		{ 0, 11, 1 },
		{ 25, 30, 6 },
		{ 25, 20, 6 },
		{ 25, 38, 6 },
		{ 25, 16, 6 },
		{ 25, 37, 6 },
		{ 25, 26, 6 },
		{ 25, 35, 6 },
		{ 0, 104, 2 }
	};
	yystate = state;

	static const yybackup_t YYNEARFAR YYBASED_CODE backup[] = {
		0,
		0,
		0,
		0,
		0,
		0,
		0,
		0
	};
	yybackup = backup;
}
