%{
/****************************************************************************
parser.y
****************************************************************************/

#include <math.h>
#include "..\tags\Options.h"
%}

//include file
%include {
// forward references
#include <string>
using namespace std;

#pragma warning ( disable : 4786 ) //identifier was truncated to 'number' characters in the debug information

}



// attribute type
%union {
  string*         string; // id
}

%token <string>      PHRASE

// keywords
%token PROJECT
%token DEP

// include file
%include {
#include "dswlexer.h"
#include "..\tags\entry.h"
}

// parser name
%name DswParser

// class definition
{
// Attributes
protected:
  DswLexer m_lexer;       // the lexical analyser
  
// Operations
public:
  DswParser(const char* file) : m_lexer(file)
                       {yytables();create();}
  
  // attribute commands
  void              newProject(string* project);
  void              newDepend(string* project);
  
private:  
  int               create();
  bool              normalize(string*& file);
  
  string            m_project;
  
}

// constructor
{
  assert(false);
}

%%
lines
  : lines EMPTY
  | lines line
  | /* empty */
  ;

line
  : error '\n'        { yyerrok(); }
  ;

EMPTY
  : DEP PHRASE { newDepend($2);}
  | PROJECT '\"' PHRASE '\"' { newProject($3);}
  | '\n'              {}
  ;


%%

/////////////////////////////////////////////////////////////////////////////
// Parser commands

int DswParser::create()
{
  if (!yycreate(&m_lexer))
    return 0;
  if (!m_lexer.yycreate(this))
    return 0;
  return 1; // success
}

/////////////////////////////////////////////////////////////////////////////
// Parser attribute commands

bool DswParser::normalize(string*& file)
{
  return false;
}

void DswParser::newProject(string* project)
{
  m_project = *project;
}
void DswParser::newDepend(string* project)
{
  for(int i=0;i<Option.projects.size();i++)
  {
    if(Option.projects[i].m_name==m_project)
    {
      Option.projects[i].dependsProjects.push_back(*project);
    }
  }
}
