#ifndef _PARSER_H
#define _PARSER_H

#include <cyacc.h>

/* #line 11 "D:\UsefulManagers_src\Parser\parser.y" */

// forward references
#include <string>
using namespace std;

#pragma warning ( disable : 4786 ) //identifier was truncated to 'number' characters in the debug information


#ifndef YYSTYPE
union tagYYSTYPE {
/* #line 23 "D:\UsefulManagers_src\Parser\parser.y" */

//  D_Operator*      doperator; // operators
  string*         string; // id

};

#define YYSTYPE union tagYYSTYPE
#endif

#define ID 257
#define STRING 258
#define PHRASE1 259
#define SOURCE 260
#define INCL 261
/* #line 43 "D:\UsefulManagers_src\Parser\parser.y" */

#include "lexer.h"
#include "..\tags\entry.h"

/////////////////////////////////////////////////////////////////////////////
// Parser

#ifndef YYDECLSPEC
#define YYDECLSPEC
#endif

class YYFAR YYDECLSPEC Parser : public yyfparser {
public:
	Parser();

protected:
	void yytables();
	virtual void yyaction(int action);
#ifdef YYDEBUG
	void YYFAR* yyattribute1(int index) const;
	void yyinitdebug(void YYFAR** p, int count) const;
#endif

public:
/* #line 52 "D:\UsefulManagers_src\Parser\parser.y" */

// Attributes
protected:
  Lexer m_lexer;       // the lexical analyser
  
// Operations
public:
  Parser(Project* project) : m_lexer(project->fileName.c_str()),m_project(project)
                        {yytables();create();}
  
  // attribute commands
  void              newProject(string* project,string* file);
  void              newInclude(string* include);
  void              newSource(string* file);
  
private:  
  int               create();
  bool              normalize(string*& file);
  
  Project*          m_project;

};

#ifndef YYPARSENAME
#define YYPARSENAME Parser
#endif

#endif
