/************************************************************
yycwrap.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

int yylexer::yywrap()
{
	return 1;
}
/************************************************************
yycwork.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include "cyacc.h"

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

int yyfparser::yywork()
{
	int errorpop = 0;
	while (1) {
		unsigned char type;
		short sr;
		yystack_t state = yypeek();			// get top state
		while (1) {
			if (yystateaction[state].lookahead) {
				int index;
				if (!yylookahead) {
					yychar = yygettoken();
					if (yychar < 0) {
						yychar = 0;
					}
					yylookahead = 1;
#ifdef YYDEBUG
					yydgettoken(yychar);
#endif
				}
				index = yystateaction[state].base + yychar;
				if (index >= 0 && index < yytokenaction_size) {
					if (yytokenaction[index].check == state) {
						type = yytokenaction[index].type;
						sr = yytokenaction[index].sr;
						break;		// escape from loop
					}
				}
			}

			type = yystateaction[state].type;
			sr = yystateaction[state].sr;
			if (type != YYAT_DEFAULT) {
				break;		// escape from loop
			}
			state = sr;
		}

		// action
		switch (type) {
		case YYAT_SHIFT:
#ifdef YYDEBUG
			yydshift(yychar);
#endif
			if (yyskip > 0) {
				yysetskip(yyskip - 1);
			}
			if (!yypush(sr)) {
#ifdef YYDEBUG
				yydabort();
#endif
				if (yywipeflg) {
					yywipe();	// clean up
				}
				return 1;
			}
			memcpy(&((char YYFAR*)yyattributestackptr)[yytop * yyattribute_size],
				yylvalptr, yyattribute_size);
			yylookahead = 0;
			continue;		// go to top of while loop
		case YYAT_REDUCE:
#ifdef YYDEBUG
			yydreduce(sr);
#endif
			yyretireflg = 0;
			if (yyreduction[sr].action != -1) {
				// user actions in here
				if (yyreduction[sr].length > 0) {
					memcpy(yyvalptr, &((char YYFAR*)yyattributestackptr)
						[(yytop + 1 - yyreduction[sr].length) * yyattribute_size],
						yyattribute_size);
				}

				yyerrorflg = 0;
				yyexitflg = 0;
				yyaction(yyreduction[sr].action);

				// check for special user requected actions
				if (yyexitflg) {
#ifdef YYDEBUG
					yydexit(yyexitcode);
#endif
					return yyexitcode;
				}
				if (yyerrorflg) {
					errorpop = yyerrorpop;
#ifdef YYDEBUG
					yydthrowerror(yyerrorpop);
#endif
					yyerrorcount++;
					break;		// go to error handler
				}
			}

			yypop(yyreduction[sr].length);
			{
				yystack_t state = yypeek();       // get top state
				short next;

				int nonterm = yyreduction[sr].nonterm;
				while (1) {
					int index = yystategoto[state].base + nonterm;
					if (index >= 0 && index < yynontermgoto_size) {
						if (yynontermgoto[index].check == state) {
							next = yynontermgoto[index].next;
							break;
						}
					}

					next = yystategoto[state].def;
					if (next == -1) {
						break;
					}
					state = next;
				}
				yyassert(next != -1);

				if (!yypush(next)) {
#ifdef YYDEBUG
					yydabort();
#endif
					if (yywipeflg) {
						yywipe();	// clean up
					}
					return 1;
				}
			}
			if (yyreduction[sr].action != -1) {
				memcpy(&((char YYFAR*)yyattributestackptr)[yytop * yyattribute_size],
					yyvalptr, yyattribute_size);
			}
			if (yyretireflg) {
#ifdef YYDEBUG
				yydretire(yyretirecode);
#endif
				return yyretirecode;
			}
			continue;		// go to top of while loop
		case YYAT_ERROR:
#ifdef YYDEBUG
			yydsyntaxerror();
#endif
			if (yyskip == 0) {
				yyerrorcount++;
				yysyntaxerror();
			}
			break;		// go to error handler
		default:
			yyassert(type == YYAT_ACCEPT);
#ifdef YYDEBUG
			yydaccept();
#endif
			return 0;
		}

		// error handler
		if (yyskip < 3 || errorpop > 0) {
#ifdef YYDEBUG
			yydattemptrecovery();
#endif
			yypopflg = 0;		// clear flag
			while (1) {
				state = yypeek();			// get top state
				while (1) {
					if (yystateaction[state].lookahead) {
						int index = yystateaction[state].base + YYTK_ERROR;
						if (index >= 0 && index < yytokenaction_size) {
							if (yytokenaction[index].check == state) {
								type = yytokenaction[index].type;
								sr = yytokenaction[index].sr;
								break;		// escape from loop
							}
						}
					}

					type = yystateaction[state].type;
					sr = yystateaction[state].sr;
					if (type != YYAT_DEFAULT) {
						break;		// escape from loop
					}
					state = sr;
				}

				if (type == YYAT_SHIFT) {
					if (errorpop <= 0) {
#ifdef YYDEBUG
						yydshift(YYTK_ERROR);
#endif
						if (!yypush(sr)) {
#ifdef YYDEBUG
							yydabort();
#endif
							if (yywipeflg) {
								yywipe();	// clean up
							}
							return 1;
						}
						yysetskip(3);		// skip 3 erroneous characters
						break;
					}
					errorpop--;
				}

				yypopflg = 1;

				// clean up any symbol attributes
				if (yydestructorptr != NULL) {
					int action;
					state = yypeek();
					action = yydestructorptr[state];
					if (action != -1) {
						// user actions in here
						memcpy(yyvalptr, &((char YYFAR*)yyattributestackptr)
							[yytop * yyattribute_size], yyattribute_size);

						yyaction(action);

						memcpy(&((char YYFAR*)yyattributestackptr)
							[yytop * yyattribute_size], yyvalptr, yyattribute_size);
					}
				}
				yypop(1);
				if (yytop < 0) {
#ifdef YYDEBUG
					yydabort();
#endif
					if (yywipeflg) {
						yywipe();	// clean up
					}
					return 1;
				}
			}
		}
		else {
			if (yylookahead) {
				if (yychar != 0) {
#ifdef YYDEBUG
					yyddiscard(yychar);
#endif
					yydiscard(yychar);

					// clean up any token attributes
					if (yytokendestptr != NULL) {
						int index = yytokendestbase + yychar;
						if (index >= 0 && index < yytokendest_size) {
							int action = yytokendestptr[index];
							if (action != -1) {
								// user actions in here
								memcpy(yyvalptr, yylvalptr, yyattribute_size);

								yyaction(action);

								memcpy(yylvalptr, yyvalptr, yyattribute_size);
							}
						}
					}

					yylookahead = 0;	// skip erroneous character
				}
				else {
#ifdef YYDEBUG
					yydabort();
#endif
					if (yywipeflg) {
						yywipe();	// clean up
					}
					return 1;
				}
			}
		}
	}
}
/************************************************************
yycwipe.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include "cyacc.h"

void yyparser::yywipe()
{
	yydestructpop(yytop + 1);
	yydestructclearin();
}
/************************************************************
yycuoflw.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

void yylexer::yyunputoverflow()
{
	yyassert(yyerr != NULL);
	fprintf(yyerr, "lex unput buffer overflow (%d)\n", (int)yyunput_size);
}
/************************************************************
yycunput.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <limits.h>
#include "clex.h"

void yylexer::yyunput(int ch)
{
	yyassert(ch >= 0 && ch <= UCHAR_MAX || ch == EOF);
	yyassert(yyunputindex >= 0 && yyunputindex <= yyunput_size);
	
	// check unput buffer size
	if (yyunputindex == yyunput_size) {
		do {
			if (yyunputgrow) {
				if (yyunput_size != 0) {
					int size = yyunput_size * 2;
					if (size / 2 == yyunput_size) {		// overflow check
						if (yysetunputsize(size)) {
							break;
						}
					}
				}
				else {
					if (yysetunputsize(100)) {
						break;
					}
				}
			}
			yyunputoverflow();
			exit(EXIT_FAILURE);
		}
		while (0);
	}

	yyunputbufptr[yyunputindex++] = ch;

	// check line number
	if (ch == '\n') {
		yylineno--;
	}

	// debugging
#ifdef YYDEBUG
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: unput: \'", (void*)this);
		yydebugoutput(string);
		yydebugoutput(ch);
		yydebugoutput("\'\n");
	}
#endif
}
/************************************************************
yycuncin.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

int yyparser::yyunclearin()
{
	if (!yylookahead && yychar != -1) {
		yylookahead = 1;
		return 1;
	}
	return 0;
}
/************************************************************
yyctoflw.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

void yylexer::yytextoverflow()
{
	yyassert(yyerr != NULL);
	fprintf(yyerr, "lex text buffer overflow (%d)\n", (int)yytext_size);
}
/************************************************************
yycsyner.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

void yyparser::yysyntaxerror()
{
	yyerror("syntax error");
}
/************************************************************
yycsusiz.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <string.h>
#include "clex.h"

#ifndef min
#define min(x, y) ((x) <= (y) ? (x) : (y))
#endif

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

int yylexer::yysetunputsize(int size)
{
	yyassert(size >= 0);
	if (yyunput_size != size) {
		if (size < yyunputindex) {
			return 0;
		}

		size_t unputbufcharsize = size * sizeof(int);
		if ((int)(unputbufcharsize / sizeof(int)) != size) {
			return 0;		// integer overflow
		}

		// allocate
		int YYFAR* unputbufptr;
		if (size <= yysunput_size) {
			unputbufptr = yysunputbufptr;
		}
		else {
			unputbufptr = (int YYFAR*)malloc(unputbufcharsize);
			if (unputbufptr == NULL) {
				return 0;
			}
		}

		// copy
		if (unputbufptr != yyunputbufptr) {
			size_t charsize = yyunput_size * sizeof(int);
			memcpy(unputbufptr, yyunputbufptr, min(unputbufcharsize, charsize));
		}

		// free
		if (yyunputbufptr != yysunputbufptr) {
			free(yyunputbufptr);
		}

		// assign
		yyunputbufptr = unputbufptr;
		yyunput_size = size;
	}
	return 1;
}
/************************************************************
yycstsiz.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <string.h>
#include "clex.h"

#ifndef min
#define min(x, y) ((x) <= (y) ? (x) : (y))
#endif

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

int yylexer::yysettextsize(int size)
{
	yyassert(size >= 0);
	if (yytext_size != size) {
		if (size < yyleng) {
			return 0;
		}

		size_t textcharsize = size + 1;	// include the '\0'
		if (textcharsize <= (size_t)size) {
			return 0;		// integer overflow
		}
		size_t statebufcharsize = size * sizeof(int);
		if ((int)(statebufcharsize / sizeof(int)) != size) {
			return 0;		// integer overflow
		}

		// allocate
		char YYFAR* text;
		int YYFAR* statebuf;
		if (size <= yystext_size) {
			text = yystext;
			statebuf = yysstatebuf;
		}
		else {
			text = (char YYFAR*)malloc(textcharsize);
			if (text == NULL) {
				return 0;
			}
			statebuf = (int YYFAR*)malloc(statebufcharsize);
			if (statebuf == NULL) {
				free(text);			// clean up
				return 0;
			}
		}

		// copy
		if (text != yytext) {
			size_t charsize = yytext_size + 1;
			memcpy(text, yytext, min(textcharsize, charsize));
		}
		if (statebuf != yystatebuf) {
			size_t charsize = yytext_size * sizeof(int);
			memcpy(statebuf, yystatebuf, min(statebufcharsize, charsize));
		}

		// free
		if (yytext != yystext) {
			free(yytext);
		}
		if (yystatebuf != yysstatebuf) {
			free(yystatebuf);
		}

		// assign
		yytext = text;
		yystatebuf = statebuf;
		yytext_size = size;
	}
	return 1;
}
/************************************************************
yycsssiz.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <string.h>
#include "cyacc.h"

#ifndef min
#define min(x, y) ((x) <= (y) ? (x) : (y))
#endif

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

int yyparser::yysetstacksize(int size)
{
	yyassert(size >= 0);
	if (yystack_size != size) {
		if (size <= yytop) {
			return 0;
		}

		size_t stackcharsize = size * sizeof(yystack_t);
		if ((int)(stackcharsize / sizeof(yystack_t)) != size) {
			return 0;		// integer overflow
		}
		size_t attributestackcharsize = size * yyattribute_size;
		if ((int)(attributestackcharsize / yyattribute_size) != size) {
			return 0;		// integer overflow
		}

		// allocate
		yystack_t YYFAR* stackptr;
		void YYFAR* attributestackptr;
		if (size <= yysstack_size) {
			stackptr = yysstackptr;
			attributestackptr = yysattributestackptr;
		}
		else {
			stackptr = (yystack_t YYFAR*)malloc(stackcharsize);
			if (stackptr == NULL) {
				return 0;
			}
			attributestackptr = malloc(attributestackcharsize);
			if (attributestackptr == NULL) {
				free(stackptr);		// clean up
				return 0;
			}
		}

		// copy
		if (stackptr != yystackptr) {
			size_t charsize = yystack_size * sizeof(yystack_t);
			memcpy(stackptr, yystackptr, min(stackcharsize, charsize));
		}
		if (attributestackptr != yyattributestackptr) {
			size_t charsize = yystack_size * yyattribute_size;
			memcpy(attributestackptr, yyattributestackptr, min(attributestackcharsize,
				charsize));
		}

		// free
		if (yystackptr != yysstackptr) {
			free(yystackptr);
		}
		if (yyattributestackptr != yysattributestackptr) {
			free(yyattributestackptr);
		}

		// assign
		yystackptr = stackptr;
		yyattributestackptr = attributestackptr;
		yystack_size = size;
	}
	return 1;
}
/************************************************************
yycsskip.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#include "cyacc.h"

#ifdef YYDEBUG
void yyparser::yysetskip(int skip)
{
	yyassert(skip >= 0);

	// debugging
	if (::yydebug || yydebug) {
		if (skip > 0) {
			if (yyskip == 0) {
				char string[128];

				sprintf(string, "%p: entering error recovery\n", (void*)this);
				yydebugoutput(string);
			}
		}
		else {
			if (yyskip > 0) {
				char string[128];

				sprintf(string, "%p: leaving error recovery\n", (void*)this);
				yydebugoutput(string);
			}
		}
	}

	yyskip = skip;
}
#endif
/************************************************************
yycsoflw.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include "cyacc.h"

void yyparser::yystackoverflow()
{
	yyerror("yacc stack overflow");
}
/************************************************************
yycsetup.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

int yyparser::yysetup()
{
	// initialise variables
	yytop = -1;
	yylookahead = 0;
	yyskip = 0;
	yyerrorcount = 0;
	yychar = -1;
	yypopflg = 0;

	// push initial state onto the stack
	if (!yypush(0)) {
#ifdef YYDEBUG
		yydabort();
#endif
		return 1;
	}
	return 0;
}
/************************************************************
yycsetin.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

void yyparser::yysetin(int token)
{
	if (token < 0) {
		token = 0;
	}
	yychar = token;
	yylookahead = 1;
}
/************************************************************
yycreset.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

void yylexer::yyreset()
{
	yyleng = 0;
	yylineno = 1;
	yyunputindex = 0;
	yymoreflg = 0;
	yyrejectflg = 0;
	yyeol = 1;
	yyoldeol = 1;
	yystart = 0;
}
/************************************************************
yycpush.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <string.h>
#include "cyacc.h"

int yyparser::yypush(yystack_t state)
{
	yytop++;		// increment first
	if (yytop == yystack_size) {
		do {
			if (yystackgrow) {
				if (yystack_size != 0) {
					int size = yystack_size * 2;
					if (size / 2 == yystack_size) {		// overflow check
						if (yysetstacksize(size)) {
							break;
						}
					}
				}
				else {
					if (yysetstacksize(100)) {
						break;
					}
				}
			}
			yytop--;

			// debugging
#ifdef YYDEBUG
			if (::yydebug || yydebug) {
				char string[128];

				sprintf(string, "%p: stack overflow\n", (void*)this);
				yydebugoutput(string);
			}
#endif

			yystackoverflow();
			return 0;
		}
		while (0);
	}
	yystackptr[yytop] = state;

	// debugging
#ifdef YYDEBUG
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: push state %d", (void*)this, (int)state);
		yydebugoutput(string);
		if (yytop > 0) {
			sprintf(string, " covering state %d", (int)yystackptr[yytop - 1]);
			yydebugoutput(string);
		}
		yydebugoutput("\n");

		// output stack contents
		if (::yydebugstack || yydebugstack) {
			yydebugoutput("\nstack");
			int n = sprintf(string, "\n     +");
			int i;
			for (i = 0; i < 10; i++) {
				n += sprintf(&string[n], " %5d", (int)i);
			}
			yydebugoutput(string);

			int rows = 1;
			if (yytop >= 0) {
				rows += yytop / 10;
			}
			for (i = 0; i < rows; i++) {
				n = sprintf(string, "\n %5d", (int)(10 * i));
				for (int j = 0; j < 10; j++) {
					int index = 10 * i + j;
					if (index <= yytop) {
						n += sprintf(&string[n], " %5d", (int)yystackptr[index]);
					}
					else {
						n += sprintf(&string[n], "     -");
					}
				}
				yydebugoutput(string);
			}
			yydebugoutput("\n\n");
		}
	}
#endif

	return 1;
}
/************************************************************
yycpop.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

#ifdef YYDEBUG
void yyparser::yypop(int num)
{
	yyassert(num >= 0);
	yytop -= num;
	yyassert(yytop >= -1);

	// debugging
	if (::yydebug || yydebug) {
		if (num > 0) {
			char string[128];

			sprintf(string, "%p: pop %d state(s)", (void*)this, (int)num);
			yydebugoutput(string);
			if (yytop >= 0) {
				sprintf(string, " uncovering state %d", (int)yystackptr[yytop]);
				yydebugoutput(string);
			}
			yydebugoutput("\n");
		}
	}
}
#endif
/************************************************************
yycpdest.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"
#include <stdlib.h>

void yyparser::yydestroy()
{
	yycleanup();
	free(yysstackptr);
	yysstackptr = NULL;
	free(yysattributestackptr);
	yysattributestackptr = NULL;

	free(yylvalptr);
	yylvalptr = NULL;
	free(yyvalptr);
	yyvalptr = NULL;
}
/************************************************************
yycpdbug.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
#include <winbase.h>
#endif
#include "cyacc.h"

#ifdef YYDEBUG

const char* yyparser::yytokenstring(int token) const
{
	yyassert(token >= 0);

	const yysymbol_t YYNEARFAR* symbol = yysymbol;
	while (symbol->name != NULL) {
		if (symbol->token == token) {
			return symbol->name;
		}
		symbol++;
	}
	return "illegal-token";
}

void yyparser::yydgettoken(int token) const
{
	yyassert(token >= 0);
	if (::yydebug || yydebug) {
		char string[128];
		const char* tokenstring = yytokenstring(token);
		yyassert(tokenstring != NULL);

		sprintf(string, "%p: get token ", (void*)this);
		yydebugoutput(string);
		yydebugoutput(tokenstring);
		sprintf(string, " (%d)\n", (int)token);
		yydebugoutput(string);
	}
}

void yyparser::yydshift(int token) const
{
	yyassert(token >= 0);
	if (::yydebug || yydebug) {
		char string[128];
		const char* tokenstring = yytokenstring(token);
		yyassert(tokenstring != NULL);

		sprintf(string, "%p: shift token ", (void*)this);
		yydebugoutput(string);
		yydebugoutput(tokenstring);
		sprintf(string, " (%d)\n", (int)token);
		yydebugoutput(string);
	}
}

void yyparser::yydreduce(int rule) const
{
	yyassert(rule >= 0);
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: reduce rule ", (void*)this);
		yydebugoutput(string);
		yydebugoutput(yyrule[rule]);
		sprintf(string, " (%d)\n", (int)rule);
		yydebugoutput(string);
	}
}

void yyparser::yydsyntaxerror() const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: syntax error\n", (void*)this);
		yydebugoutput(string);
	}
}

void yyparser::yydaccept() const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: accept\n", (void*)this);
		yydebugoutput(string);
	}
}

void yyparser::yydabort() const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: abort\n", (void*)this);
		yydebugoutput(string);
	}
}

void yyparser::yyddiscard(int token) const
{
	yyassert(token >= 0);
	if (::yydebug || yydebug) {
		char string[128];
		const char* tokenstring = yytokenstring(token);
		yyassert(tokenstring != NULL);

		sprintf(string, "%p: discard token ", (void*)this);
		yydebugoutput(string);
		yydebugoutput(tokenstring);
		sprintf(string, " (%d)\n", (int)token);
		yydebugoutput(string);
	}
}

void yyparser::yydexit(int exitcode) const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: exit with code %d\n", (void*)this, (int)exitcode);
		yydebugoutput(string);
	}
}

void yyparser::yydthrowerror(int errorpop) const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: throw error and pop %d error handling state(s)\n",
			(void*)this, (int)errorpop);
		yydebugoutput(string);
	}
}

void yyparser::yydretire(int retirecode) const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: retire with code %d\n", (void*)this, (int)retirecode);
		yydebugoutput(string);
	}
}

void yyparser::yydattemptrecovery() const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: attempting error recovery\n", (void*)this);
		yydebugoutput(string);
	}
}

void yyparser::yydebugoutput(const char* string) const
{
	yyassert(string != NULL);

#ifdef _WIN32
	if (yydebugout != NULL) {
#else
		yyassert(yydebugout != NULL);
#endif
		while (*string != '\0') {
			putc(*string++, yydebugout);
		}

		if (::yydebugflush || yydebugflush) {
			fflush(yydebugout);
		}
#ifdef _WIN32
	}
	else {
		OutputDebugString(string);
		Sleep(0);		// makes sure debug string is processed
	}
#endif
}

#endif
/************************************************************
yycpcrea.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"
#include <stdlib.h>

int yyparser::yycreate(yylexer YYFAR* lexerptr)
{
	yylexerptr = lexerptr;

	// stack
	if (yysstack_size != 0) {
		size_t stackcharsize;
		size_t attributestackcharsize;

		stackcharsize = yysstack_size * sizeof(yystack_t);
		if ((int)(stackcharsize / sizeof(yystack_t)) != yysstack_size) {
			return 0;		// integer overflow
		}
		attributestackcharsize = yysstack_size * yyattribute_size;
		if ((int)(attributestackcharsize / yyattribute_size) != yysstack_size) {
			return 0;		// integer overflow
		}
		
		yysstackptr = (yystack_t YYFAR*)malloc(stackcharsize);
		if (yysstackptr == NULL) {
			return 0;
		}
		yysattributestackptr = malloc(attributestackcharsize);
		if (yysattributestackptr == NULL) {
			free(yysstackptr);
			return 0;
		}
	}
	else {
		yysstackptr = NULL;
		yysattributestackptr = NULL;
	}
	yystack_size = yysstack_size;
	yystackptr = yysstackptr;
	yyattributestackptr = yysattributestackptr;

	// yylval
	yylvalptr = malloc(yyattribute_size);
	if (yylvalptr == NULL) {
		free(yysstackptr);
		free(yysattributestackptr);
		return 0;
	}

	// yyval ($$)
	yyvalptr = malloc(yyattribute_size);
	if (yyvalptr == NULL) {
		free(yysstackptr);
		free(yysattributestackptr);
		free(yylvalptr);
		return 0;
	}

	return 1;
}
/************************************************************
yycpcon.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

yyparser::yyparser()
{
	yystackptr = NULL;
	yysstackptr = NULL;
	yyattributestackptr = NULL;
	yysattributestackptr = NULL;
	yystack_size = 0;
	yysstack_size = 0;
	yytop = -1;
	yyattribute_size = 0;
	yyvalptr = NULL;
	yylookahead = 0;
	yychar = -1;
	yywipeflg = 1;
	yypopflg = 0;
	yyskip = 0;
	yyexitflg = 0;
	yyretireflg = 0;
	yyerrorflg = 0;
	yyexitcode = 0;
	yyretirecode = 0;
	yyerrorpop = 0;
	yylexerptr = NULL;
	yystackgrow = 1;
	yylvalptr = NULL;
	yyerr = stderr;
	yyerrorcount = 0;

#ifdef YYDEBUG
	yydebug = 0;
	yydebugstack = 0;
	yydebugflush = 0;
	yydebugout = stdout;
#endif
}

yyparser::~yyparser()
{
	yydestroy();
}
/************************************************************
yycpcln.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include "cyacc.h"

void yyparser::yycleanup()
{
	if (yystackptr != yysstackptr) {
		free(yystackptr);
		yystackptr = yysstackptr;
	}
	if (yyattributestackptr != yysattributestackptr) {
		free(yyattributestackptr);
		yyattributestackptr = yysattributestackptr;
	}
	yystack_size = yysstack_size;

	yytop = -1;
}
/************************************************************
yycparse.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"

int yyparser::yyparse()
{
	int n = yysetup();
	if (n != 0) {
		return n;
	}
	return yywork();
}
/************************************************************
yycoutpt.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#include <limits.h>
#include "clex.h"

void yylexer::yyoutput(int ch)
{
	// debugging
#ifdef YYDEBUG
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: output: \'", (void*)this);
		yydebugoutput(string);
		yydebugoutput(ch);
		yydebugoutput("\'\n");
	}
#endif

	yyassert(yyout != NULL);

#ifdef __BORLANDC__
	putc((char)ch, yyout);
#else
	putc(ch, yyout);
#endif
}
/************************************************************
yycless.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

void yylexer::yyless(int length)
{
	yyassert(length >= 0 && length <= yyleng);
	while (yyleng > length) {
		yyunput((unsigned char)yytext[--yyleng]);
	}
	if (yyleng > 0) {
		yyeol = (unsigned char)(yytext[yyleng - 1] == '\n');
	}
	else {
		yyeol = yyoldeol;
	}
}
/************************************************************
yycldest.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"
#include <stdlib.h>

void yylexer::yydestroy()
{
	yycleanup();
	free(yystext);
	yystext = NULL;
	free(yysstatebuf);
	yysstatebuf = NULL;
	free(yysunputbufptr);
	yysunputbufptr = NULL;
}
/************************************************************
yycldbug.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
#include <winbase.h>
#endif
#include "clex.h"

#ifdef YYDEBUG

void yylexer::yydmatch(int expr) const
{
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: match: \"", (void*)this);
		yydebugoutput(string);
		for (int i = 0; i < yyleng; i++) {
			yydebugoutput(yytext[i]);
		}
		sprintf(string, "\", %d\n", (int)expr);
		yydebugoutput(string);
	}
}

void yylexer::yydebugoutput(const char* string) const
{
	yyassert(string != NULL);

#ifdef _WIN32
	if (yydebugout != NULL) {
#else
		yyassert(yydebugout != NULL);
#endif
		while (*string != '\0') {
			putc(*string++, yydebugout);
		}

		if (::yydebugflush || yydebugflush) {
			fflush(yydebugout);
		}
#ifdef _WIN32
	}
	else {
		OutputDebugString(string);
		Sleep(0);		// makes sure debug string is processed
	}
#endif
}

#endif
/************************************************************
yyclcrea.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"
#include <stdlib.h>

int yylexer::yycreate(yyparser YYFAR* parserptr)
{
	yyparserptr = parserptr;

	size_t textcharsize;
	size_t statebufcharsize;
	size_t unputbufcharsize;

	// get sizes first
	textcharsize = yystext_size + 1;	// include the '\0'
	if (textcharsize <= (size_t)yystext_size) {
		return 0;		// integer overflow
	}
	if (yystext_size != 0) {
		statebufcharsize = yystext_size * sizeof(int);
		if ((int)(statebufcharsize / sizeof(int)) != yystext_size) {
			return 0;		// integer overflow
		}
	}
	else {
		statebufcharsize = 0;
	}
	if (yysunput_size != 0) {
		unputbufcharsize = yysunput_size * sizeof(int);
		if ((int)(unputbufcharsize / sizeof(int)) != yysunput_size) {
			return 0;		// integer overflow
		}
	}
	else {
		unputbufcharsize = 0;
	}

	// allocate the memory if necessary
	yystext = (char YYFAR*)malloc(textcharsize);
	if (yystext == NULL) {
		return 0;
	}
	if (statebufcharsize != 0) {
		yysstatebuf = (int YYFAR*)malloc(statebufcharsize);
		if (yysstatebuf == NULL) {
			free(yystext);
			return 0;
		}
	}
	else {
		yysstatebuf = NULL;
	}
	if (unputbufcharsize != 0) {
		yysunputbufptr = (int YYFAR*)malloc(unputbufcharsize);
		if (yysunputbufptr == NULL) {
			free(yystext);
			free(yysstatebuf);
			return 0;
		}
	}
	else {
		yysunputbufptr = NULL;
	}

	// assign any other variables
	yytext_size = yystext_size;
	yytext = yystext;
	yystatebuf = yysstatebuf;
	yyunput_size = yysunput_size;
	yyunputbufptr = yysunputbufptr;

	// makes sure we are ready to go
	yyreset();

	return 1;
}
/************************************************************
yyclcon.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

yylexer::yylexer()
{
	yystart = 0;
	yyeol = 1;
	yyoldeol = 1;
	yystatebuf = NULL;
	yysstatebuf = NULL;
	yystext = NULL;
	yytext_size = 0;
	yystext_size = 0;
	yyunputbufptr = NULL;
	yysunputbufptr = NULL;
	yyunput_size = 0;
	yysunput_size = 0;
	yyunputindex = 0;
	yymoreflg = 0;
	yyrejectflg = 0;
	yyreturnflg = 0;
	yyparserptr = NULL;
	yytextgrow = 1;
	yyunputgrow = 1;
	yyin = stdin;
	yyout = stdout;
	yyerr = stderr;
	yytext = NULL;
	yyleng = 0;
	yylineno = 1;

	// debugging
#ifdef YYDEBUG
	yydebug = 0;
	yydebugflush = 0;
	yydebugout = stdout;
#endif
}

yylexer::~yylexer()
{
	yydestroy();
}
/************************************************************
yyclcln.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <malloc.h>
#include "clex.h"

void yylexer::yycleanup()
{
	if (yytext != yystext) {
		free(yytext);
		yytext = yystext;
	}
	if (yystatebuf != yysstatebuf) {
		free(yystatebuf);
		yystatebuf = yysstatebuf;
	}
	if (yyunputbufptr != yysunputbufptr) {
		free(yyunputbufptr);
		yyunputbufptr = yysunputbufptr;
	}
	yytext_size = yystext_size;
	yyunput_size = yysunput_size;

	if (yytext != NULL) {
		*yytext = '\0';
	}
	yyleng = 0;
	yyunputindex = 0;
}
/************************************************************
yycinput.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#include <ctype.h>
#include "clex.h"

int yylexer::yyinput()
{
	int ch;
	if (yyunputindex > 0) {
		ch = yyunputbufptr[--yyunputindex];
	}
	else {
		ch = yygetchar();
	}
	if (ch == '\n') {
		yylineno++;
	}

#ifdef YYDEBUG
	if (::yydebug || yydebug) {
		char string[128];

		sprintf(string, "%p: input: \'", (void*)this);
		yydebugoutput(string);
		yydebugoutput(ch);
		yydebugoutput("\'\n");
	}
#endif

	return ch;
}
/************************************************************
yycgtok.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "cyacc.h"
#include "clex.h"

int yyparser::yygettoken()
{
	yyassert(yylexerptr != NULL);
	return yylexerptr->yylex();
}
/************************************************************
yycgetch.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#include "clex.h"

int yylexer::yygetchar()
{
	yyassert(yyin != NULL);
	return getc(yyin);
}
/************************************************************
yycflex.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <limits.h>
#include "clex.h"

int yyflexer::yylex()
{
	while (1) {
		int state = 1 + yystart;
		if (yyeol) {
			state++;
		}
	
		// yymore
		if (yymoreflg) {
			yymoreflg = 0;		// clear flag
		}
		else {
			yyleng = 0;
			yyoldeol = yyeol;
		}
		int oldleng = yyleng;

		// look for a string
		do {
			// get input character (look ahead character)
			int ch = yyinput();
			yyassert(ch >= 0 && ch <= UCHAR_MAX || ch == EOF);
			if (ch == EOF) {
				break;
			}
			
			// check for possible overflow
			if (yyleng == yytext_size) {
				do {
					if (yytextgrow) {
						if (yytext_size != 0) {
							int size = yytext_size * 2;
							if (size / 2 == yytext_size) {		// overflow check
								if (yysettextsize(size)) {
									break;
								}
							}
						}
						else {
							if (yysettextsize(100)) {
								break;
							}
						}
					}
					yytextoverflow();
					exit(EXIT_FAILURE);
				}
				while (0);
			}

			// look for a transition
			do {
				int index = yystate[state].base + ch;
				if (index >= 0 && index < yytransitionmax) {
					if (yytransition[index].check == state) {
						state = yytransition[index].next;
						break;	// found a transition
					}
				}
				state = yystate[state].def;
				if (state < 0) {
					if (ch >= 0 && ch <= 0xff) {
						state = -state;
					}
					else {
						state = 0;
					}
					break;		// default transition
				}
			}
			while (state != 0);

			int leng = yyleng;		// slightly more efficient
			yytext[leng] = (char)ch;
			yystatebuf[leng] = state;
			leng++;
			yyleng = leng;
		}
		while (state != 0 && (yystate[state].def != 0 || yystate[state].base != 0));

		// now find a match
		if (yyleng > oldleng) {
			int rejectmatch = 0;
			while (1) {
				int match = yystate[yystatebuf[yyleng - 1]].match;
				if (rejectmatch != 0) {
					if (match < 0) {
						int index = -match;
						do {
							match = yymatch[index++];
						}
						while (match > 0 && match <= rejectmatch);
					}
					else {
						if (match == rejectmatch) {
							match = 0;
						}
					}
					rejectmatch = 0;
				}
				else {
					if (match < 0) {
						match = yymatch[-match];
					}
				}
				if (match > 0) {
					// check for backup
					if (yybackup[match]) {
						while (yyleng > oldleng) {
							int index = yystate[yystatebuf[yyleng - 1]].match;
							if (index < 0) {
								if (yyback(&yymatch[-index], -match)) {
									break;	// found an expression
								}
							}
							yyleng--;
							yyunput((unsigned char)yytext[yyleng]);
						}
					}
					yytext[yyleng] = '\0';
#ifdef YYDEBUG
					yydmatch(match);
#endif
					yyrejectflg = 0;		// clear flag
					int rejectleng = yyleng;

					if (yyleng > 0) {
						yyeol = (unsigned char)(yytext[yyleng - 1] == '\n');
					}
					else {
						yyeol = yyoldeol;
					}

					// perform user action
					int token = yyaction(match);

					if (yyreturnflg) {
						return token;
					}
					if (!yyrejectflg) {
						break;
					}
					if (rejectleng == yyleng) {
						rejectmatch = match;
					}
				}
				else if (yyleng > oldleng + 1) {
					yyleng--;
					yyunput((unsigned char)yytext[yyleng]);
				}
				else {
					yyeol = (unsigned char)(yytext[0] == '\n');
					yyoutput(yytext[0]);	// non-matched character
					break;
				}
			}
		}
		else {
			yyassert(yyleng == oldleng);

			// handles <<EOF>> rules
			int index = 0;
			int match = yystate[state].match;
			if (match < 0) {
				index = -match;
				match = yymatch[index++];
			}
			while (match > 0) {
				yytext[yyleng] = '\0';
#ifdef YYDEBUG
				yydmatch(match);
#endif
				yyrejectflg = 0;		// clear flag

				// perform user action
				int token = yyaction(match);

				if (yyreturnflg) {
					return token;
				}
				if (!yyrejectflg) {
					break;
				}

				if (index == 0) {
					break;
				}
				match = yymatch[index++];
			}

			if (yywrap()) {
				yyoldeol = 1;
				yyeol = 1;
				yystart = 0;
				return 0;			// eof reached
			}
		}
	}
}
/************************************************************
yycerror.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#include "cyacc.h"

void yyparser::yyerror(const char YYFAR* text)
{
	yyassert(text != NULL);
	yyassert(yyerr != NULL);
	while (*text != '\0') {
		putc(*text++, yyerr);
	}
	putc('\n', yyerr);
}
/************************************************************
yycecho.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdio.h>
#include "clex.h"

void yylexer::yyecho()
{
	for (int i = 0; i < yyleng; i++) {
		yyoutput(yytext[i]);
	}
}
/************************************************************
yycdoutp.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include <ctype.h>
#include "clex.h"

#ifdef YYDEBUG
void yylexer::yydebugoutput(int ch) const
{
	char string[32];
	switch (ch) {
	case EOF:
		strcpy(string, "EOF");
		break;
	case '\n':
		strcpy(string, "\\n");
		break;
	case '\t':
		strcpy(string, "\\t");
		break;
	case '\v':
		strcpy(string, "\\v");
		break;
	case '\b':
		strcpy(string, "\\b");
		break;
	case '\r':
		strcpy(string, "\\r");
		break;
	case '\f':
		strcpy(string, "\\f");
		break;
	case '\a':
		strcpy(string, "\\a");
		break;
	case '\\':
		strcpy(string, "\\");
		break;
	case '\?':
		strcpy(string, "\\\?");
		break;
	case '\'':
		strcpy(string, "\\\'");
		break;
	case '\"':
		strcpy(string, "\\\"");
		break;
	default:
		if (isascii(ch) && isgraph(ch)) {
			string[0] = (char)ch;
			string[1] = '\0';
		}
		else {
			sprintf(string, "\\%03o", (unsigned int)(unsigned char)ch);
		}
		break;
	}
	yydebugoutput(string);
}

#endif
/************************************************************
yycdisc.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include "cyacc.h"

#ifdef __BORLANDC__
#pragma argsused
#endif

void yyparser::yydiscard(int token)
{
	yyassert(token > 0);
	// do nothing
}
/************************************************************
yycdepop.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include "cyacc.h"

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

void yyparser::yydestructpop(int num)
{
	yyassert(num >= 0);
	yyassert(yytop - num >= -1);

	if (yydestructorptr != NULL) {
		while (num > 0) {
			yystack_t state = yypeek();
			int action = yydestructorptr[state];
			if (action != -1) {
				// user actions in here
				memcpy(yyvalptr, &((char YYFAR*)yyattributestackptr)
					[yytop * yyattribute_size], yyattribute_size);

				yyaction(action);

				memcpy(&((char YYFAR*)yyattributestackptr)
					[yytop * yyattribute_size], yyvalptr, yyattribute_size);
			}
			yypop(1);
			num--;
		}
	}
	else {
		yypop(num);
	}
}
/************************************************************
yycdeci.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include "cyacc.h"

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

void yyfparser::yydestructclearin()
{
	if (yylookahead) {
		// clean up any token attributes
		if (yytokendestptr != NULL) {
			int index = yytokendestbase + yychar;
			if (index >= 0 && index < yytokendest_size) {
				int action = yytokendestptr[index];
				if (action != -1) {
					// user actions in here
					memcpy(yyvalptr, yylvalptr, yyattribute_size);

					yyaction(action);

					memcpy(yylvalptr, yyvalptr, yyattribute_size);
				}
			}
		}
		yylookahead = 0;
	}
}
/************************************************************
yyccwork.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include "cyacc.h"

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

int yycparser::yywork()
{
	int errorpop = 0;
	while (1) {
		yystack_t state = yypeek();			// get top state

		int index = yycstateaction[state];
		while (1) {
			if (yyctokenaction[index].token == YYTK_ALL) {
				if (yyctokenaction[index].type == YYAT_DEFAULT) {
					state = yyctokenaction[index].sr;
					index = yycstateaction[state];
					continue;
				}
				break;
			}

			if (!yylookahead) {
				yychar = yygettoken();
				if (yychar < 0) {
					yychar = 0;
				}
				yylookahead = 1;
#ifdef YYDEBUG
				yydgettoken(yychar);
#endif
			}
			if (yyctokenaction[index].token == yychar) {
				break;
			}
			index++;
		}
		unsigned char type = yyctokenaction[index].type;
		short sr = yyctokenaction[index].sr;

		// action
		switch (type) {
		case YYAT_SHIFT:
#ifdef YYDEBUG
			yydshift(yychar);
#endif
			if (yyskip > 0) {
				yysetskip(yyskip - 1);
			}
			if (!yypush(sr)) {
#ifdef YYDEBUG
				yydabort();
#endif
				if (yywipeflg) {
					yywipe();	// clean up
				}
				return 1;
			}
			memcpy(&((char YYFAR*)yyattributestackptr)[yytop * yyattribute_size],
				yylvalptr, yyattribute_size);
			yylookahead = 0;
			continue;		// go to top of while loop
		case YYAT_REDUCE:
#ifdef YYDEBUG
			yydreduce(sr);
#endif
			yyretireflg = 0;
			if (yyreduction[sr].action != -1) {
				// user actions in here
				if (yyreduction[sr].length > 0) {
					memcpy(yyvalptr, &((char YYFAR*)yyattributestackptr)
						[(yytop + 1 - yyreduction[sr].length) * yyattribute_size],
						yyattribute_size);
				}

				yyerrorflg = 0;
				yyexitflg = 0;
				yyaction(yyreduction[sr].action);

				// check for special user requected actions
				if (yyexitflg) {
#ifdef YYDEBUG
					yydexit(yyexitcode);
#endif
					return yyexitcode;
				}
				if (yyerrorflg) {
					errorpop = yyerrorpop;
#ifdef YYDEBUG
					yydthrowerror(yyerrorpop);
#endif
					yyerrorcount++;
					break;		// go to error handler
				}
			}

			yypop(yyreduction[sr].length);
			{
				yystack_t state = yypeek();       // get top state

				int nonterm = yyreduction[sr].nonterm;
				int index = yycstategoto[state];
				while (1) {
					if (yycnontermgoto[index].nonterm == -1) {
						if (yycnontermgoto[index].next != -1) {
							state = yycnontermgoto[index].next;
							index = yycstategoto[state];
							continue;
						}
						break;
					}
					if (yycnontermgoto[index].nonterm == nonterm) {
						break;
					}
					index++;
				}
				short next = yycnontermgoto[index].next;
				yyassert(next != -1);

				if (!yypush(next)) {
#ifdef YYDEBUG
					yydabort();
#endif
					if (yywipeflg) {
						yywipe();	// clean up
					}
					return 1;
				}
			}
			if (yyreduction[sr].action != -1) {
				memcpy(&((char YYFAR*)yyattributestackptr)[yytop * yyattribute_size],
					yyvalptr, yyattribute_size);
			}
			if (yyretireflg) {
#ifdef YYDEBUG
				yydretire(yyretirecode);
#endif
				return yyretirecode;
			}
			continue;		// go to top of while loop
		case YYAT_ERROR:
#ifdef YYDEBUG
			yydsyntaxerror();
#endif
			if (yyskip == 0) {
				yyerrorcount++;
				yysyntaxerror();
			}
			break;		// go to error handler
		default:
			yyassert(type == YYAT_ACCEPT);
#ifdef YYDEBUG
			yydaccept();
#endif
			return 0;
		}

		// error handler
		if (yyskip < 3 || yyerrorpop > 0) {
#ifdef YYDEBUG
			yydattemptrecovery();
#endif
			yypopflg = 0;		// clear flag
			while (yytop >= 0) {
				state = yypeek();			// get top state
				index = yycstateaction[state];
				while (1) {
					if (yyctokenaction[index].token == YYTK_ALL) {
						if (yyctokenaction[index].type == YYAT_DEFAULT) {
							state = yyctokenaction[index].sr;
							index = yycstateaction[state];
							continue;
						}
						break;
					}
					if (yyctokenaction[index].token == YYTK_ERROR) {
						break;
					}
					index++;
				}
				type = yyctokenaction[index].type;
				sr = yyctokenaction[index].sr;

				if (type == YYAT_SHIFT) {
					if (errorpop <= 0) {
#ifdef YYDEBUG
						yydshift(YYTK_ERROR);
#endif
						if (!yypush(sr)) {
#ifdef YYDEBUG
							yydabort();
#endif
							if (yywipeflg) {
								yywipe();	// clean up
							}
							return 1;
						}
						yysetskip(3);		// skip 3 erroneous characters
						break;
					}
					errorpop--;
				}

				yypopflg = 1;

				// clean up any symbol attributes
				if (yydestructorptr != NULL) {
					state = yypeek();
					int action = yydestructorptr[state];
					if (action != -1) {
						// user actions in here
						memcpy(yyvalptr, &((char YYFAR*)yyattributestackptr)
							[yytop * yyattribute_size], yyattribute_size);
        
						yyaction(action);

						memcpy(&((char YYFAR*)yyattributestackptr)
							[yytop * yyattribute_size], yyvalptr, yyattribute_size);
					}
				}
				yypop(1);
				if (yytop < 0) {
#ifdef YYDEBUG
					yydabort();
#endif
					if (yywipeflg) {
						yywipe();	// clean up
					}
					return 1;
				}
			}
		}
		else {
			if (yylookahead) {
				if (yychar != 0) {
#ifdef YYDEBUG
					yyddiscard(yychar);
#endif
					yydiscard(yychar);

					// clean up any token attributes
					if (yyctokendestptr != NULL) {
						const yyctokendest_t YYNEARFAR* tokendestptr = yyctokendestptr;
						while (tokendestptr->token != 0) {
							if (tokendestptr->token == yychar) {
								// user actions in here
								memcpy(yyvalptr, yylvalptr, yyattribute_size);

								yyaction(tokendestptr->action);

								memcpy(yylvalptr, yyvalptr, yyattribute_size);								
								break;
							}
							tokendestptr++;
						}
					}

					yylookahead = 0;	// skip erroneous character
				}
				else {
#ifdef YYDEBUG
					yydabort();
#endif
					if (yywipeflg) {
						yywipe();	// clean up
					}
					return 1;
				}
			}
		}
	}
}
/************************************************************
yycclex.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <limits.h>
#include "clex.h"

int yyclexer::yylex()
{
	while (1) {
		int state = 1 + yystart;
		if (yyeol) {
			state++;
		}
	
		// yymore
		if (yymoreflg) {
			yymoreflg = 0;		// clear flag
		}
		else {
			yyleng = 0;
			yyoldeol = yyeol;
		}
		int oldleng = yyleng;

		// look for a string
		do {
			// get input character (lookahead character)
			int ch = yyinput();
			yyassert(ch >= 0 && ch <= UCHAR_MAX || ch == EOF);
			if (ch == EOF) {
				break;
			}
			
			// check for possible overflow
			if (yyleng == yytext_size) {
				do {
					if (yytextgrow) {
						if (yytext_size != 0) {
							int size = yytext_size * 2;
							if (size / 2 == yytext_size) {		// overflow check
								if (yysettextsize(size)) {
									break;
								}
							}
						}
						else {
							if (yysettextsize(100)) {
								break;
							}
						}
					}
					yytextoverflow();
					exit(EXIT_FAILURE);
				}
				while (0);
			}

			// look for a transition
			int index = yystate[state].base;
			while (1) {
				if (yyctransition[index].next == -1) {
					state = yystate[state].def;
					if (state <= 0) {
						if (state < 0) {
							if (ch >= 0 && ch <= 0xff) {
								state = -state;
							}
							else {
								state = 0;
							}
						}
						break;
					}
					index = yystate[state].base;
				}
				if (ch >= yyctransition[index].first &&
					ch <= yyctransition[index].last) {
					state = yyctransition[index].next;
					break;
				}
				index++;
			}

			int leng = yyleng;		// slightly more efficient code
			yytext[leng] = (char)ch;
			yystatebuf[leng] = state;
			leng++;
			yyleng = leng;
		}
		while (state != 0 && (yystate[state].def != 0 || yystate[state].base != 0));

		// now find a match
		if (yyleng > oldleng) {
			int rejectmatch = 0;
			while (1) {
				int match = yystate[yystatebuf[yyleng - 1]].match;
				if (rejectmatch != 0) {
					if (match < 0) {
						int index = -match;
						do {
							match = yymatch[index++];
						}
						while (match > 0 && match <= rejectmatch);
					}
					else {
						if (match == rejectmatch) {
							match = 0;
						}
					}
					rejectmatch = 0;
				}
				else {
					if (match < 0) {
						match = yymatch[-match];
					}
				}
				if (match > 0) {
					// check for backup
					if (yybackup[match]) {
						while (yyleng > oldleng) {
							int index = yystate[yystatebuf[yyleng - 1]].match;
							if (index < 0) {
								if (yyback(&yymatch[-index], -match)) {
									break;	// found an expression
								}
							}
							yyleng--;
							yyunput((unsigned char)yytext[yyleng]);
						}
					}
					yytext[yyleng] = '\0';
#ifdef YYDEBUG
					yydmatch(match);
#endif
					yyrejectflg = 0;		// clear flag
					int rejectleng = yyleng;

					if (yyleng > 0) {
						yyeol = (unsigned char)(yytext[yyleng - 1] == '\n');
					}
					else {
						yyeol = yyoldeol;
					}

					// perform user action
					int token = yyaction(match);

					if (yyreturnflg) {
						return token;
					}
					if (!yyrejectflg) {
						break;
					}
					if (rejectleng == yyleng) {
						rejectmatch = match;
					}
				}
				else if (yyleng > oldleng + 1) {
					yyleng--;
					yyunput((unsigned char)yytext[yyleng]);
				}
				else {
					yyeol = (unsigned char)(yytext[0] == '\n');
					yyoutput(yytext[0]);	// non-matched character
					break;
				}
			}
		}
		else {
			yyassert(yyleng == oldleng);

			// handles <<EOF>> rules
			int index = 0;
			int match = yystate[state].match;
			if (match < 0) {
				index = -match;
				match = yymatch[index++];
			}
			while (match > 0) {
				yytext[yyleng] = '\0';
#ifdef YYDEBUG
				yydmatch(match);
#endif
				yyrejectflg = 0;		// clear flag

				// perform user action
				int token = yyaction(match);

				if (yyreturnflg) {
					return token;
				}
				if (!yyrejectflg) {
					break;
				}

				if (index == 0) {
					break;
				}
				match = yymatch[index++];
			}

			if (yywrap()) {
				yyoldeol = 1;
				yyeol = 1;
				yystart = 0;
				return 0;			// eof reached
			}
		}
	}
}
/************************************************************
yyccdeci.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include <string.h>
#include "cyacc.h"

// the Visual C++ v1.52 compiler generates an error in NT if this isn't present!
#ifdef _MSC_VER
#if defined(M_I86HM) && defined(NDEBUG)
#pragma function(memcpy)
#endif
#endif

void yycparser::yydestructclearin()
{
	if (yylookahead) {
		// clean up any token attributes
		if (yyctokendestptr != NULL) {
			const yyctokendest_t YYNEARFAR* tokendestptr = yyctokendestptr;
			while (tokendestptr->token != 0) {
				if (tokendestptr->token == yychar) {
					// user actions in here
					memcpy(yyvalptr, yylvalptr, yyattribute_size);

					yyaction(tokendestptr->action);

					memcpy(yylvalptr, yyvalptr, yyattribute_size);								
					break;
				}
				tokendestptr++;
			}
		}
		yylookahead = 0;
	}
}
/************************************************************
yycback.cpp
This file can be freely modified for the generation of
custom code.

Copyright (c) 1999-2000 Bumble-Bee Software Ltd.
************************************************************/

#include "clex.h"

int yylexer::yyback(const yymatch_t YYNEARFAR* p, int action) const
{
	yyassert(p != NULL);
	yyassert(action < 0);
	while (*p != 0) {
		if (*p++ == action) {
			return 1;
		}
	}
	return 0;
}
