/*****************************************************************************
*   $Id: options.h,v 8.1 1999/03/04 04:16:38 darren Exp $
*
*   Copyright (c) 1998-1999, Darren Hiebert
*
*   This source code is released for free distribution under the terms of the
*   GNU General Public License.
*
*   This module is a global include file.
*****************************************************************************/
#ifndef _OPTIONS_H
#define _OPTIONS_H

/*============================================================================
=   Include files
============================================================================*/

#include "ctags.h"	/* to define LANG_COUNT */
#include "entry.h"	/* to define TAG_COUNT */

struct  optionValues
{
  optionValues();
  int include[TAG_COUNT];
  vector<CString> ignore;	  /* -I  name of file containing tokens to ignore */
  bool append;          /* -a  append to "tags" files */
  bool access;
  CString tagFileName;  /* -o  name of tags file */
  vector<CString> langMap[(int)LANG_COUNT];  /* --langmap  language-extension map */
  vector<Project> projects;
};

extern  optionValues    Option;

bool isIgnoreToken (const char* const name, bool& pIgnoreParens);
langType getExtensionLanguage(CString);

#endif	/* _OPTIONS_H */
