/*****************************************************************************
*   $Id: read.h,v 8.2 1999/04/12 05:55:05 darren Exp $
*
*   Copyright (c) 1998-1999, Darren Hiebert
*
*   This source code is released for free distribution under the terms of the
*   GNU General Public License.
*
*    al interface to read.c
*****************************************************************************/
#ifndef _READ_H
#define _READ_H

#define EOF_FILE 256

#define getFileName()		File.m_name
#define getFileLine()		File.lineNumber

/*  Maintains the state of the current source file.
 */
struct  inputFile{
    CString m_name;		/* name of the input file */
    // stream used for reading the file
    HANDLE hFile;
    HANDLE hFileMapping;
    char* mapViewOfFile;
    char* mapIndexOfFile;
    char* mapLastIndexOfFile;

    bool newLine;    /* will the next character begin a new line? */
    langType	language;	/* language of input file */

    /*  Contains data pertaining to the original source file in which the tag
     *  was defined. This may be different from the input file when #line
     *  directives are processed (i.e. the input file is preprocessor output).
     */
     unsigned long lineNumber;	/* line number in the source file */
};

extern inputFile File;

bool  fileOpen (CString fileName, const langType language = LANG_CPP);
void  fileClose ();
int   fileGetc ();
void  fileUngetc();
char* readLine(int line);


#endif	/* _READ_H */
