// TagsListDP.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#include "stdafx.h"
#include <COMMCTRL.H>
#include <afxcmn.h>
#include "Commands.h"
#include "TagsListDP.h"
#include "Tags\read.h"
#include "tags\parse.h"
#include "Utils.h"

extern tagFile TagFile;

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TagsListDP dialog


TagsListDP::TagsListDP() : CDlgMgr(),m_ctlListTagsChilds(this),m_ctlListTagsparents(this)
{
  avalibleCommands = AutoClose;
  m_GrType = 0;
  m_processFocus = true;
}

BOOL TagsListDP::OnInitDialog()
{
	CDlgMgr::OnInitDialog();

  m_ctlListTags.m_manager = this;

#if _MSC_VER >= 1200
  m_ctlListTags.ModifyStyle(0,TVS_INFOTIP | TVS_FULLROWSELECT);
#endif

  CImageList* pimagelist = new CImageList();
	pimagelist->Create(16, 10, TRUE/*bMask*/, 6, 4);

  CBitmap	bitmap;
	bitmap.LoadBitmap(IDB_IMAGES);
	pimagelist->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	m_ctlListTags.SetImageList(pimagelist, TVSIL_NORMAL);

  m_ctlListTagsChilds.makeColumns("Children",0);
  m_ctlListTagsparents.makeColumns("Parents",0);

  addInTree(TagFile.classes);

  // graph
  doit(0);
  m_zoom.SetRange(1,1000);
	m_zoom.SetPos(100);

  return true;
}

void TagsListDP::addInTree(ClassItem& item)
{
  m_ctlListTags.SetRedraw(false);
  for(int i=0;i<TAG_COUNT;i++)
  {
    char str[200];
    sprintf(str,"%s (%d)",g_tagFolders[i],item.m_children[i].size());
    TV_INSERTSTRUCT treeCtrlItem;
	  treeCtrlItem.hParent = TVI_ROOT;
	  treeCtrlItem.hInsertAfter = TVI_LAST;
	  treeCtrlItem.item.mask = TVIF_SELECTEDIMAGE | TVIF_IMAGE | TVIF_TEXT | TVIF_PARAM;
	  treeCtrlItem.item.lParam = NULL;
    treeCtrlItem.item.iImage = treeCtrlItem.item.iSelectedImage = i;
    treeCtrlItem.item.pszText = str;
    HTREEITEM parent = m_ctlListTags.InsertItem(&treeCtrlItem);
    m_ctlListTags.SetItemState(parent, TVIS_BOLD, TVIS_BOLD );
    for (ClassItemIter it = item.m_children[i].begin(); it!= item.m_children[i].end();it++)
      addInTree(*it,parent,i);
  }
  m_ctlListTags.SetRedraw(true);
}

void TagsListDP::addInTree(ClassItem& item,HTREEITEM hParent,int kind)
{
 	TV_INSERTSTRUCT treeCtrlItem;
	treeCtrlItem.hParent = hParent;
	treeCtrlItem.hInsertAfter = TVI_LAST;
	treeCtrlItem.item.mask = TVIF_SELECTEDIMAGE | TVIF_IMAGE | TVIF_TEXT | TVIF_PARAM;
  treeCtrlItem.item.pszText = (char*)(const char*)item.m_name;
	treeCtrlItem.item.lParam = long(&item);
  treeCtrlItem.item.iSelectedImage = treeCtrlItem.item.iImage = kind;
  HTREEITEM hTreeItem = m_ctlListTags.InsertItem(&treeCtrlItem);
  for(int i=0;i<TAG_COUNT;i++)
    for (ClassItemIter it = item.m_children[i].begin(); it!= item.m_children[i].end();it++)
      addInTree(*it,hTreeItem,i);
}

void TagsListDP::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

  DDX_Control(pDX, IDC_TAGSLIST, m_ctlListTags);
  DDX_Control(pDX, IDC_TAGS_CHILD_LIST, m_ctlListTagsChilds);
  DDX_Control(pDX, IDC_TAGS_PARENTS, m_ctlListTagsparents);
	DDX_Control(pDX, IDC_SLIDER1, m_zoom);
	DDX_Control(pDX, IDC_ADDFLOWCTRL1, m_AddFlow);
  DDX_Radio(pDX,IDC_RADIO1,m_GrType);
}


BEGIN_MESSAGE_MAP(TagsListDP, CDlgMgr)
  ON_NOTIFY(TVN_SELCHANGED, IDC_TAGSLIST, OnTracksSelchanged)
  ON_WM_SIZE()
  ON_WM_CONTEXTMENU( )
	ON_WM_HSCROLL()
  ON_COMMAND(ID__EXCLUDE_ASFUNCTION,OnNewAsFunction)
  ON_COMMAND(ID__EXCLUDE_BEFORECLASS,OnNewAsClass)
  ON_COMMAND(IDC_RADIO1,OnChangeGraph)
  ON_COMMAND(IDC_RADIO2,OnChangeGraph)
  ON_COMMAND(IDC_RADIO3,OnChangeGraph)
  ON_COMMAND(IDC_SAVE_BUTTON2,OnSave)
END_MESSAGE_MAP() 

void TagsListDP::addItems(CMListCtrl& lst,TagVector& vect,bool openFile)
{
  lst.DeleteAllItems();
  int i=0;
  for (TagVector::iterator it = vect.begin(); it!= vect.end();it++)
  {
    if(openFile)
    {
      if(fileOpen(TagFile.m_files[it->file].m_name.c_str()))
      {
        auto_ptr<char> line(readLine(it->line));
        lst.InsertItem(i++,line.get(),TagItem(it->file+TAG_COUNT,it->line).value);
        fileClose();
      }
    }
    else
      lst.InsertItem(i++,TagFile.classes.m_children[it->kind][it->index].m_name,it->value);
  }
  lst.SetWidths();
}

void TagsListDP::OnTracksSelchanged(NMHDR* pNMHDR, LRESULT* pResult)
{
  ClassItem *item = (ClassItem*)(((NM_TREEVIEW*)pNMHDR)->itemNew.lParam);
  if(item)
  {
    if(item->fileIndex>=0 && item->m_line>1)
      Do_Select(item->m_name);
    addItems(m_ctlListTagsChilds,item->m_ichildren,item->m_line==0);
    addItems(m_ctlListTagsparents,item->m_iparents,item->fileIndex==-1);
  }                
}

bool TagsListDP::openSelected(HTREEITEM  selected)
{
  if(selected)
  {
     m_ctlListTags.SelectItem(selected);
     SetFocus();
     return true;
  }
  return false;
}


void TagsListDP::OnESC()
{
  ShowWindow(SW_HIDE);
}

void TagsListDP::OnSelect(CMListCtrl& ctrl)
{
	for( CListSelIterator iter(ctrl);iter;)
	{
    void* qqq = (void*)ctrl.GetItemData(iter);
    TagItem& item = (TagItem&)qqq;
    if(item.kind<TAG_COUNT)
      CCommands::Get()->selectTagByName(TagFile.classes.m_children[item.kind][item.index].m_name);
    else
    {
      CCommands::Get()->SimpleOpenDoc(TagFile.m_files[item.kind-TAG_COUNT].m_name.c_str(),item.index);
      if(CCommands::getValue(getName()+"AutoClose",1))
        OnESC();
    }
  }
}


ClassItem* menuItem = 0;

void TagsListDP::OnContextMenu( CWnd* wnd, CPoint point )
{
  if(&m_ctlListTags==wnd)
  {
    UINT pFlags;
    int x = point.x;
    int y = point.y;
    ScreenToClient(&point);
    HTREEITEM hItem = m_ctlListTags.HitTest(point,&pFlags);
    if(hItem && (TVHT_ONITEM & pFlags))
    {
      menuItem = (ClassItem*)m_ctlListTags.GetItemData(hItem);
      if(menuItem)
      {
        CMenu menu;
        VERIFY(menu.LoadMenu(IDR_TAG_MENU));
        CMenu* pMenu = menu.GetSubMenu(0);
        ASSERT(pMenu);
        pMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, x,y, AfxGetMainWnd());
      }
    }
  }
  /*if(&m_AddFlow==wnd)
  {
    CNode node = m_AddFlow.GetPointedNode();	
    if (node != NULL)
      m_AddFlow.SetSelectedNode(node);
    else
    {
      CLink link = m_AddFlow.GetPointedLink();	
      if (link != NULL)
        m_AddFlow.SetSelectedLink(link);
    }
    CMenu menu;
    VERIFY(menu.LoadMenu(IDR_NODE_MENU));
    CMenu* pMenu = menu.GetSubMenu(0);
    ASSERT(pMenu);
    pMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, x,y, AfxGetMainWnd());
  }*/
}

void TagsListDP::OnNewAsFunction()
{
  ASSERT(menuItem);
  CCommands::Get()->OnNewExclude(menuItem->m_name,false);
}
void TagsListDP::OnNewAsClass()
{
  ASSERT(menuItem);
  CCommands::Get()->OnNewExclude(menuItem->m_name,true);
}

void TagsListDP::OnSize( UINT f, int cx, int cy )
{
  CDialog::OnSize(f, cx, cy); // don't allow to scroll page
                              // don't try with one window
#ifdef _DEBUG
  int count = 0;
  CWnd* wnd0 = GetTopWindow();
  do  count++; while((wnd0 = wnd0->GetNextWindow()));
  ASSERT(count==9);
#endif

  static struct Pos 
  {
     float x;
     float y;
     float width;
     float height;
  }positions[9] = { 
                      {0     , 0   ,   0.25, 1},
                      {0.25  , 0   ,   0.25, 0.5},
                      {0.25  , 0.5 ,   0.25, 0.5},
                      {0.5F  , 0   ,   0.5F, 0.95F},
                      
                      {0.5F  , 0.95F,  0.2F,  0.05F}, // 
					            {0.7F  , 0.96F,  0.03F, 0.03F}, // save
                      {0.76F , 0.95F,  0.08F, 0.05F}, // class
                      {0.84F , 0.95F,  0.08F, 0.05F}, // file
                      {0.92F , 0.95F,  0.08F, 0.05F}, // project
                  };

  CRect rc;
  GetClientRect(&rc);
  CWnd* wnd = GetTopWindow();
  int i = 0;
  do
  {
     wnd->MoveWindow(rc.Width()*positions[i].x,rc.Height()*positions[i].y,rc.Width()*positions[i].width,rc.Height()*positions[i].height);
     i++;
  }while((wnd = wnd->GetNextWindow()));
}


void TagsListDP::OnChangeGraph()
{
  UpdateData(true);
  doit(m_GrType);
}

BEGIN_EVENTSINK_MAP(TagsListDP, CDlgMgr)
    //{{AFX_EVENTSINK_MAP(TagsListDP)
	ON_EVENT(TagsListDP, IDC_ADDFLOWCTRL1, -600 /* Click */, OnClickAddflowctrl2, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()
