#if !defined(AFX_TAGSLISTDP_H__E7A40B42_2BE1_11D3_B5C4_0020AFDD89D7__INCLUDED_)
#define AFX_TAGSLISTDP_H__E7A40B42_2BE1_11D3_B5C4_0020AFDD89D7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TagsListDP.h : header file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//
#include <atlcom.h>

#include "graph\addflow.h"

#include "DlgMgr.h"
#include "TagsListCtrl.h"
#include "tags\entry.h"


typedef vector<int>  IntVector;

class GraphClass 
{
  public:
   GraphClass() : m_level(-1),addChildrens(false),row(-1),setRightPosition(false){}
   CString       m_name;
    
   IntVector     m_iparents;
   IntVector     m_ichildren;

   int           m_level;

   bool          addChildrens;
   bool          setRightPosition;
   int           row;
   int           rowOnLevel;
};

typedef vector<GraphClass>  GraphClasses;


/////////////////////////////////////////////////////////////////////////////
// TagsListDP dialog

class TagsListDP : public CDlgMgr
{
// Construction
public:
	TagsListDP();

// Dialog Data
	//{{AFX_DATA(TagsListDP)
	CTagsListCtrl m_ctlListTags;
	CMListCtrl m_ctlListTagsChilds;
  CMListCtrl m_ctlListTagsparents;
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

  bool openSelected(HTREEITEM  selected);
  void addInTree(ClassItem& item);
  void addInTree(ClassItem& item,HTREEITEM hParent,int type);
  void OnTracksSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
  
  void OnClickAddflowctrl2();
  
  virtual void OnESC();
  virtual CString getName() {return "Tags List";}

  void OnChangeGraph();
  BOOL m_GrType;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TagsListDP)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog();
  void OnContextMenu( CWnd*, CPoint point );
  void OnSize( UINT f, int cx, int cy );
	//}}AFX_VIRTUAL

// Implementation
protected:

    void      doit(int type);

    void      FillList();

    virtual void OnSelect(CMListCtrl& ctrl);

    void Select(CString& str,GraphClasses& cl);
    void Do_Select(CString str);

    void addItems(CMListCtrl& list,TagVector& vect,bool openFile);

    void OnNewAsFunction();
    void OnNewAsClass();

  	CSliderCtrl	m_zoom;
	  CAddFlow	m_AddFlow;

    bool m_processFocus;


	void OnSave();

	// Generated message map functions
	//{{AFX_MSG(TagsListDP)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	DECLARE_EVENTSINK_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TAGSLISTDP_H__E7A40B42_2BE1_11D3_B5C4_0020AFDD89D7__INCLUDED_)
