// UsefulManagers.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <initguid.h>
#include "Commands.h"
#include "Registry.h"
#include "DlgMgr.h"
#include "UsefulManagersTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_Commands, CCommands)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// The one and only CUsefulManagersApp object

/////////////////////////////////////////////////////////////////////////////
// CUsefulManagersApp

class CUsefulManagersApp : public CWinApp
{
 public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUsefulManagersApp)
	public:
  virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL
};

CUsefulManagersApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CUsefulManagersApp initialization
//#include "AddInComm\AICLoader.h"
//#include "AddInComm\AddInComm.h"

BOOL CUsefulManagersApp::InitInstance()                           
{
   //aiclLoadAICLibrary(AfxGetInstanceHandle());
#ifdef _DEBUG
//    if(!aiclIsAICLoaded())
  //    AfxMessageBox("Can't load AIC");
#endif
	_Module.Init(ObjectMap, m_hInstance);
  SetRegistryKey(_T("AndNow East\\"));
  //ASSERT(AfxOleInit());
  AfxEnableControlContainer();
	return CWinApp::InitInstance();
}

int CUsefulManagersApp::ExitInstance()
{
 	_Module.Term();
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// Special entry points required for inproc servers

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return _Module.GetClassObject(rclsid, riid, ppv);
}

STDAPI DllCanUnloadNow(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (AfxDllCanUnloadNow()==S_OK && _Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

// by exporting DllRegisterServer, you can use regsvr32.exe
STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	HRESULT hRes = S_OK;

	// Registers object, typelib and all interfaces in typelib
  hRes = _Module.RegisterServer(true);
	if (FAILED(hRes))
		return hRes;

	// Register description of this add-in object in its own
	//  "/Description" subkey.
	// TODO:  If you add more add-ins to this module, you need
	//  to register all of their descriptions, each description
	//  in each add-in object's registry CLSID entry:
	// HKEY_CLASSES_ROOT\Clsid\{add-in CLSID}\Description="add-in description"

  _ATL_OBJMAP_ENTRY* pEntry = _Module.m_pObjMap;
	USES_CONVERSION;
	LPOLESTR lpOleStr;
	StringFromCLSID(*pEntry->pclsid, &lpOleStr);
	LPTSTR lpsz = OLE2T(lpOleStr);
  RegKey key(RegKey::ClassesRootClsid,lpsz);

	RegKey value(key,_T("Description"));
  const char* data = _T("Class structure, windows managers and etc.");
  value.SetValue("", REG_SZ,(const unsigned char *)data,strlen(data));
	CoTaskMemFree(lpOleStr);
	return hRes;
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	HRESULT hRes = S_OK;
	_Module.UnregisterServer();
	return hRes;
}


/////////////////////////////////////////////////////////////////////////////
// Debugging support

// GetLastErrorDescription is used in the implementation of the VERIFY_OK
//  macro, defined in stdafx.h.

#ifdef _DEBUG

void GetLastErrorDescription(CComBSTR& bstr)
{
	CComPtr<IErrorInfo> pErrorInfo;
	if (GetErrorInfo(0, &pErrorInfo) == S_OK)
		pErrorInfo->GetDescription(&bstr);
}               

#endif //_DEBUG

