// Utils.cpp : implementation file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//
#include "stdafx.h"

#include "utils.h"
#include "Commands.h"
#include "TagsListDP.h"
#include "Registry.h"

//using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

RegIterator::RegIterator(CString path,bool v) : value_enumerator(v)
{
  addSlash(path);
  CreateKey(path,hKey);
  i=0;
  operator++(1);
}

void RegIterator::operator++(int)
{
  unsigned long size = 200;
  valid = ( (value_enumerator ? ::RegEnumValue(hKey, i++, szBuf, &size,0,0,0,0) :
                                ::RegEnumKeyEx(hKey, i++, szBuf, &size,0,0,0,0)
            ) != ERROR_NO_MORE_ITEMS);
}

int RegIterator::value()
{
  DWORD  count = 200;
  unsigned char str[200]; DWORD type;
  if(ERROR_SUCCESS==RegQueryValueEx(hKey,szBuf,0,&type,str,&count))
    return atoi((char*)str);
  return -1;
}

void CreateKey(CString fullPath)
{
  HKEY hKey;
  CreateKey(fullPath,hKey);
}

void CreateKey(CString fullPath,HKEY& hKey)
{
  DWORD dwResult,dw=0;
  HKEY hAppKey = AfxGetApp()->GetAppRegistryKey();
  if ((dwResult = ::RegOpenKeyEx(hAppKey,fullPath,0,KEY_ALL_ACCESS,&hKey)) != ERROR_SUCCESS)
    dwResult = RegCreateKeyEx(hAppKey,fullPath,0,REG_NONE,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,0,&hKey,&dw);
}

void DeleteValue(CString fullPath,CString str)
{
  RegKey key(AfxGetApp()->GetAppRegistryKey(),fullPath);
  key.DeleteValue(str);
}

void SetValue(CString fullPath,CString str,CString value)
{
  RegKey key(AfxGetApp()->GetAppRegistryKey(),fullPath);
  RegValue val(key,str);
  val = value;
}

DocIterator::DocIterator(CComQIPtr<IDocuments, &IID_IDocuments>& pDocuments)
{
	CComPtr<IUnknown> pUnk;
  if(valid=(SUCCEEDED(pDocuments->get__NewEnum(&pUnk)) && pUnk != NULL))
  {
    pNewEnum = pUnk;
    operator++(1);
  }
}

void DocIterator::operator++(int)
{
	VARIANT varTextDocument;
	while(valid= (pNewEnum->Next(1, &varTextDocument, NULL) == S_OK))
	{
		_ASSERTE(varTextDocument.vt == VT_DISPATCH);
		pGenDoc = varTextDocument.pdispVal;
		VariantClear(&varTextDocument);
    if(pGenDoc)
      break;
	}
}

ItemIterator::ItemIterator(TagsListDP* dlgTags,HTREEITEM hParent) : m_ctlListTags(dlgTags->m_ctlListTags)
{
  hItem = m_ctlListTags.GetChildItem(hParent);
  if(hItem)
    item = (ClassItem*)(m_ctlListTags.GetItemData(hItem));
}

void ItemIterator::operator ++(int)
{
  hItem = m_ctlListTags.GetNextSiblingItem(hItem);
  if(hItem)
    item = (ClassItem*)(m_ctlListTags.GetItemData(hItem));
}



ProjectIterator::ProjectIterator()
{
  CComPtr<IDispatch> pDispProjects;
	VERIFY_OK(CCommands::Get()->GetApplication()->get_Projects(&pDispProjects));
	pProjects = pDispProjects;
	VERIFY_OK(pProjects->get_Count(&lCount));
  i = 1;
}

ProjectIterator::operator bool() 		
{
  if(i < lCount+1)
  {
		CComVariant Vari = i++;
		CComPtr<IGenericProject> pGenProject;
		VERIFY_OK(pProjects->Item(Vari, &pGenProject));
		pProject = pGenProject;
    return true;
  }
  return false;
}

CString ProjectIterator::getName()
{
  BSTR bszStr;
  VERIFY_OK(pProject->get_Name(&bszStr));
  return bszStr;
}
CString ProjectIterator::getFullName()
{
  BSTR bszStr;
 	VERIFY_OK(pProject->get_FullName(&bszStr));
  return bszStr;
}

  
char str[10];
char* GetFind(int i)
{
  sprintf(str,"Find%d",i);
  return str;
}
char* GetFile(int i)
{
  sprintf(str,"File%d",i++);
  return str;
}

CListSelIterator::CListSelIterator(CMListCtrl& ctrl) : m_ctrl(ctrl)
{
 	p = m_ctrl.GetFirstSelectedItemPosition();
}

CListSelIterator::operator bool()
{
	POSITION p0 = p;
  iItem = m_ctrl.GetNextSelectedItem(p);
	return p0!=0; 
}

CString findExtension(const CString& strFile)
{
  int ich = strFile.ReverseFind(_T('.'));
  if (ich > 0)
  {
		ASSERT(ich < strFile.GetLength());
  	return strFile.Mid(ich+1);
  }
	else
		return CString();
}


char* itoa(int i)
{
  static char buf[20];
  itoa(i,buf,10);
  return buf;
}

