// Utils.h : header file
// COPYRIGHT (C) 1999-2000 by Mike Melnikov zmike@andnow.ru
//

#if !defined(AFX_UTILS_H__9E2BD958_202C_11D3_B5C4_0020AFDD89D7__INCLUDED_)
#define AFX_UTILS_H__9E2BD958_202C_11D3_B5C4_0020AFDD89D7__INCLUDED_

const CString RegSessions     = "Workspaces\\Sessions\\";
const CString RegFavorites    = "Workspaces\\Favorites\\";
const CString RegExclude      = "ExcludeTags";
const CString RegExcludeClass = "ExcludeTagsBeforeClass";
const CString RegBuild        = "Workspaces\\Build\\";
const CString RegBookMarks    = "Workspaces\\BookMarks\\";

void CreateKey(CString fullPath);
void CreateKey(CString fullPath,HKEY& hKey);
void DeleteValue(CString fullPath,CString str);
void SetValue(CString fullPath,CString str,CString value="");

char* GetFind(int i);
char* GetFile(int i);

char* itoa(int i);

#include "TagsListCtrl.h"
#include "tags\entry.h"
#include <ObjModel\appguid.h>

class ATL_NO_VTABLE  RegIterator
{
 public:
  RegIterator(CString path,bool value_enumerator=true);
  ~RegIterator() {::RegCloseKey(hKey);}
  void operator++(int);
  operator bool() {return valid;}
  operator CString() { return szBuf;}
  operator int() { return i-1;}
  int      value();
 protected:
  HKEY hKey;
  char szBuf[200];
  int i;
  bool valid;
  bool value_enumerator;
};

class ATL_NO_VTABLE  DocIterator
{
 public:
  DocIterator(CComQIPtr<IDocuments, &IID_IDocuments>& pDocuments);
  void operator++(int);
  operator bool() {return valid;}
  CComQIPtr<IGenericDocument, &IID_IGenericDocument> operator ->() {return pGenDoc;}
  operator CComQIPtr<IGenericDocument, &IID_IGenericDocument>&() {return pGenDoc;}
  operator CComPtr<IGenericDocument>() {return pGenDoc;}
 protected:
  CComQIPtr<IGenericDocument, &IID_IGenericDocument> pGenDoc;

  CComQIPtr<IEnumVARIANT, &IID_IEnumVARIANT> pNewEnum;
  bool valid;
};

class ATL_NO_VTABLE  ItemIterator
{
 public:
  ItemIterator(TagsListDP* dlgTags,HTREEITEM hParent);
  void operator++(int);
  operator bool()       {return hItem ? true : false;}
  ClassItem* get()      {return item;}
  ClassItem* operator ->() {return item;}
  operator HTREEITEM()  {return hItem;}
 protected:
  ClassItem* item;
  CTagsListCtrl& m_ctlListTags;
  HTREEITEM hItem;
};

#include <ObjModel\bldguid.h>

class ATL_NO_VTABLE  ProjectIterator
{
 public:
  ProjectIterator();
  operator bool(); //Get the next project
  CString getName();
  CString getFullName();
  operator int()    {return i-2;}
  CComQIPtr<IBuildProject, &IID_IBuildProject> operator ->() {return pProject;}
 protected:
  long i;
  long lCount;
  CComQIPtr<IBuildProject, &IID_IBuildProject> pProject;
	CComQIPtr<IProjects, &IID_IProjects> pProjects;
};


class ATL_NO_VTABLE  CListSelIterator
{
 public:
  CListSelIterator(CMListCtrl& ctrl);
  operator bool();
  operator int()      {return iItem;}
 protected:
  CMListCtrl& m_ctrl;
  int iItem;
  
#if _MSC_VER < 1200
  int count;
  int p;
#else
  POSITION p;
#endif
};

CString findExtension(const CString& strFile);

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMMANDS_H__9E2BD958_202C_11D3_B5C4_0020AFDD89D7__INCLUDED)
